;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                           S y m b O S    I n f o                           @
;@                                                                            @
;@             (c) 2004-2007 by Prodatron / SymbiosiS (Jrn Mika)             @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

relocate_start

;==============================================================================
;### CODE AREA ################################################################
;==============================================================================

;### APPLICATION HEADER #######################################################

;header structure
prgdatcod       equ 0           ;Length of the code area (OS will place this area everywhere)
prgdatdat       equ 2           ;Length of the data area (screen manager data; OS will place this area inside a 16k block of one 64K bank)
prgdattra       equ 4           ;Length of the transfer area (stack, message buffer, desktop manager data; placed between #c000 and #ffff of a 64K bank)
prgdatorg       equ 6           ;Original origin of the assembler code
prgdatrel       equ 8           ;Number of entries in the relocator table
prgdatstk       equ 10          ;Length of the stack in bytes
prgdatcrn       equ 12          ;Length of crunched data      (*NOT YET SUPPORTED*)
prgdatctp       equ 14          ;Cruncher type (0=uncrunched) (*NOT YET SUPPORTED*)
prgdatnam       equ 15          ;Application name. The end of the string must be filled with 0.
prgdatidn       equ 48          ;"SymExe10" SymbOS executable file identification
prgdatcex       equ 56          ;additional memory for code area (will be reserved directly behind the loaded code area)
prgdatdex       equ 58          ;additional memory for data area (see above)
prgdattex       equ 60          ;additional memory for transfer area (see above)
prgdatres       equ 62          ;*reserviert* (26 bytes)
prgdatver       equ 88          ;required OS version (1.0)
prgdatism       equ 90          ;Application icon (small version), 8x8 pixel, SymbOS graphic format
prgdatibg       equ 109         ;Application icon (big version), 24x24 pixel, SymbOS graphic format
prgdatlen       equ 256         ;length of header

prgpstdat       equ 6           ;start address of the data area
prgpsttra       equ 8           ;start address of the transfer area
prgpstspz       equ 10          ;additional sub process or timer IDs (4*1)
prgpstbnk       equ 14          ;64K ram bank (1-8), where the application is located
prgpstmem       equ 48          ;additional memory areas; 8 memory areas can be registered here, each entry consists of 5 bytes
                                ;00  1B  Ram bank number (1-8; if 0, the entry will be ignored)
                                ;01  1W  Address
                                ;03  1W  Length
prgpstnum       equ 88          ;Application ID
prgpstprz       equ 89          ;Main process ID

prgcodbeg   dw prgdatbeg-prgcodbeg  ;length of code area
            dw prgtrnbeg-prgdatbeg  ;length of data area
            dw prgtrnend-prgtrnbeg  ;length of transfer area
prgdatadr   dw #1000                ;original origin                    POST address data area
prgtrnadr   dw relocate_count       ;number of relocator table entries  POST address transfer area
prgprztab   dw prgstk-prgtrnbeg     ;stack length                       POST table processes
            dw 0                    ;crunched data length
prgbnknum   db 0                    ;crunched data type                 POST bank number
            db "SymbOS Information":ds 32-18:db 0 ;Name
prgmemtab   db "SymExe10"           ;SymbOS-EXE-identifier              POST table reserved memory areas
            dw 0                    ;additional code memory
            dw 0                    ;additional data memory
            dw 0                    ;additional transfer memory
            ds 26                   ;*reserviert*
            db 0,2                  ;required OS version (2.0)

prgicnsml   db 2,8,8,#00,#00,#00,#46,#00,#8C,#00,#46,#23,#8C,#33,#08,#33,#8C,#00,#00
prgicnbig   db 6,24,24
            ds 6*24,#FF


;### PRGPRZ -> Application process
dskprzn     db 2
sysprzn     db 3
windatprz   equ 3   ;Process ID
prgwin      db 0    ;main window ID

prgprz  ld a,(prgprzn)
        ld (syswininf+windatprz),a

        call syschk

        ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,syswininf
        call msgsnd             ;open window
prgprz1 call msgdsk             ;get message -> IXL=Status, IXH=sender ID
        cp MSR_DSK_WOPNER
        jp z,prgend             ;memory full -> quit process
        cp MSR_DSK_WOPNOK
        jr nz,prgprz1           ;message is not "window has been opened" -> ignore
        ld a,(prgmsgb+4)
        ld (prgwin),a           ;window has been opened -> store ID

prgprz0 call msgget             ;*** check for messages
        jr nc,prgprz0
        cp MSR_DSK_WCLICK       ;* window has been clicked?
        jr nz,prgprz0
        ld a,(iy+2)             ;* yes, check what exactly
        cp DSK_ACT_CLOSE        ;* close clicked
        jr z,prgend
        cp DSK_ACT_CONTENT      ;* content clicked
        jr nz,prgprz0
        ld l,(iy+8)
        ld h,(iy+9)
        ld a,l
        or h
        jr z,prgprz0

;### PRGEND -> quit application
prgend  ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        ld (iy+0),MSC_SYS_PRGEND    ;send "please kill me" message to system manager
        ld a,(prgcodbeg+prgpstnum)
        ld (iy+1),a
        rst #10
prgend0 rst #30                     ;wait for death
        jr prgend0


;==============================================================================
;### SUB-ROUTINES #############################################################
;==============================================================================

;### MSGGET -> check for message for application
;### Output     CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
msgget  ld a,(prgprzn)
        db #dd:ld l,a           ;IXL=our own process ID
        db #dd:ld h,-1          ;IYL=sender ID (-1 = receive messages from any sender)
        ld iy,prgmsgb           ;IY=Messagebuffer
        rst #08                 ;get Message -> IXL=Status, IXH=sender ID
        or a
        db #dd:dec l
        ret nz
        ld iy,prgmsgb
        ld a,(iy+0)
        or a
        jp z,prgend
        scf
        ret

;### MSGDSK -> wait for a message from the desktop manager
;### Ausgabe    (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgdsk  call msgget
        jr nc,msgdsk            ;no Message
        ld a,(dskprzn)
        db #dd:cp h
        jr nz,msgdsk            ;Message from someone else -> ignore
        ld a,(prgmsgb)
        ret

;### MSGSND -> send message to desktop process
;### Eingabe    C=command, B/E/D/L/H=Parameter1/2/3/4/5
msgsnd  ld a,(dskprzn)
msgsnd1 db #dd:ld h,a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),b
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        rst #10
        ret

;### SYSCHK -> get computer type and adjust logo
syschk  ld hl,jmp_sysinf        ;*** get Computer Type
        ld de,256*1+5
        ld ix,cfgcpctyp
        ld iy,66+2+6+8
        rst #28
        ld a,(cfgcpctyp)
        and 15
        cp 8
        ret c
        ld hl,syslogo_msx       ;*** adjust Logo
        cp 12
        jr c,syschk2
        ld hl,syslogo_pcw
syschk2 ld de,3*40+syslogo+3+40-13
        ld a,10
syschk1 ld bc,13
        ldir
        ex de,hl
        ld c,40-13
        add hl,bc
        ex de,hl
        dec a
        jr nz,syschk1
        ret


;==============================================================================
;### DATA AREA ################################################################
;==============================================================================

prgdatbeg

;### SYMBOS INFO ##############################################################

systiticn   db 2,8,8,#00,#00,#00,#46,#00,#8C,#00,#46,#23,#8C,#33,#08,#33,#8C,#00,#00
systitinft  db "About SymbOS",0
systxtinf1t db "The CPC, MSX and PCW New Millenium",0
systxtinf2t db "Multitasking Operating System",0

systxtinf3t db "RELEASE 2.0 - (c)SymbiosiS 2000-2007",0

systxtinf4t db "Concept, design and realisation by",0
systxtinf5t db "Prodatron / SymbiosiS (Joern Mika)",0

systxtinf9t db "Respects to the MSX & CPC community!",0

systxtsub00 db "Additional credits...",0
systxtsub10 db "CROWN",0
systxtsub11 db   "CPC Crown Cruncher",0
systxtsub20 db "SONIC_AKA_T",0
systxtsub21 db   "MSX loader and mouse routines",0
systxtsub30 db "NYYRIKKI",0
systxtsub31 db   "MSX Basic booting routines",0

systxtsub40 db "Many thanx to...",0
systxtsub50 db "TREBMINT",0
systxtsub51 db   "for SymStudio and motivation",0
systxtsub90 db "DR. ZED",0
systxtsub91 db   "for SYMBiFACE II & 3, the CPCs'",0
systxtsub92 db   "revolutionary expansion cards",0
systxtsub60 db "RICHARD WILSON",0
systxtsub61 db   "for WinApe, the best CPC emulator",0
systxtsub70 db "DVIK + more",0
systxtsub71 db   "for the great BlueMSX emulator",0
systxtsub80 db "JOHN ELLIOTT",0
systxtsub81 db   "for the one&only Joyce emulator",0
systxtsuba0 db "MSX.ORG FORUM AND SYMBOS ML",0
systxtsuba1 db   "for all your fantastic (!) support",0

sysbutok    db "Ok",0

syslogo db 40,160,16
db #78,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1
db #78,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1
db #78,#F0,#F0,#F4,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#F0,#F0,#F0,#F2,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1
db #78,#F0,#8C,#00,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#89,#F8,#F0,#F0,#CE,#00,#36,#F0,#C6,#00,#32,#F0,#F0,#F0,#F0,#8F,#0F,#F8,#C7,#0F,#1F,#F0,#F3,#0F,#3F,#E1
db #78,#E1,#13,#CE,#32,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#11,#F0,#F0,#E3,#01,#4E,#11,#F0,#09,#EF,#01,#F0,#F0,#F0,#E3,#1F,#8F,#3C,#C7,#0F,#0F,#78,#C7,#3F,#0F,#E9
db #78,#C2,#34,#E1,#3E,#BF,#F0,#D7,#FB,#7F,#3E,#E7,#7E,#E1,#13,#1F,#F0,#84,#74,#F0,#01,#E1,#12,#F0,#1F,#F0,#F0,#F0,#C7,#7C,#E1,#3E,#C7,#78,#C3,#7C,#8F,#F8,#C3,#6D
db #78,#C2,#13,#F8,#F0,#19,#F1,#11,#C4,#07,#01,#0E,#12,#C2,#03,#08,#79,#09,#F0,#F0,#01,#E1,#01,#FC,#F0,#F0,#F0,#F0,#87,#F8,#F0,#F0,#C7,#F8,#C3,#7C,#1F,#F0,#F0,#E1
db #78,#E1,#00,#12,#F0,#11,#C2,#34,#88,#79,#01,#EA,#32,#84,#7C,#84,#69,#12,#F0,#E1,#10,#F0,#0C,#01,#F0,#F0,#F0,#F0,#87,#F8,#F0,#F0,#C7,#7F,#0F,#7D,#1E,#F0,#F0,#E1
db #78,#F0,#C3,#01,#F1,#10,#8C,#F9,#11,#E1,#32,#C2,#74,#89,#F0,#84,#EA,#34,#F0,#E2,#32,#F0,#F3,#08,#78,#F0,#F0,#F0,#87,#F8,#F0,#F0,#C7,#0F,#1F,#F0,#1F,#F0,#F0,#E1
db #6A,#34,#F0,#11,#F1,#13,#12,#E1,#32,#C2,#34,#84,#79,#11,#F0,#19,#C2,#34,#F0,#8C,#79,#16,#F0,#80,#78,#F0,#F0,#F0,#87,#F8,#F1,#7E,#C7,#78,#F0,#F0,#1F,#F0,#E3,#ED
db #4A,#33,#CF,#12,#F1,#00,#74,#C2,#34,#84,#78,#89,#E0,#01,#E6,#32,#C2,#13,#CF,#11,#E1,#01,#FF,#09,#F0,#F0,#F0,#F0,#C7,#7C,#E3,#3E,#C7,#78,#F0,#F0,#8F,#F8,#C7,#69
db #69,#08,#00,#7C,#E1,#01,#F0,#C4,#78,#89,#F1,#12,#C2,#4E,#01,#78,#F1,#00,#01,#7C,#F0,#08,#00,#36,#F0,#F0,#F0,#F0,#E1,#0F,#0F,#7C,#C7,#78,#F0,#F0,#C7,#0F,#0F,#E9
db #78,#F7,#F8,#F0,#E2,#32,#F0,#F5,#F0,#FA,#F0,#F8,#F2,#F1,#FC,#F0,#F0,#F3,#F8,#F0,#F0,#F1,#FE,#F0,#F0,#F0,#F0,#F0,#F0,#E7,#3F,#F0,#F7,#F8,#F0,#F0,#F0,#8F,#7E,#E1
db #78,#F0,#F0,#E1,#08,#78,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1
db #78,#F0,#F0,#E2,#1F,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1
db #78,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E1

syslogo_msx
db #E3,#1F,#F0,#8F,#78,#C7,#0F,#3E,#E3,#3E,#E3,#3E,#E1
db #E3,#0F,#F0,#0F,#78,#8F,#F9,#1F,#F1,#1F,#C7,#7C,#E1
db #E3,#0F,#F1,#2F,#78,#9F,#F0,#BE,#F0,#8F,#8F,#F8,#E1
db #E3,#4F,#E9,#2F,#78,#8F,#7C,#F0,#F0,#C7,#1F,#F0,#E1
db #E3,#4F,#69,#6B,#78,#C7,#0F,#7C,#F0,#E3,#3E,#F0,#E1
db #E3,#6B,#6B,#6B,#78,#F1,#8F,#3E,#F0,#E3,#3E,#F0,#E1
db #E3,#6B,#4F,#EB,#78,#F0,#F1,#1F,#F0,#C7,#1F,#F0,#E1
db #E3,#79,#0F,#E3,#78,#9F,#F0,#8F,#F0,#8F,#8F,#F8,#E1
db #E3,#79,#0F,#E3,#78,#8F,#F9,#1F,#F1,#1F,#C7,#7C,#E1
db #E3,#78,#9F,#E3,#78,#C7,#0F,#3E,#E3,#3E,#E3,#3E,#E1

syslogo_pcw
db #E3,#0F,#0F,#F8,#F1,#8F,#1F,#F8,#3C,#97,#E3,#F8,#E1
db #E3,#0F,#0F,#3C,#E3,#1F,#8F,#7C,#3E,#8F,#E3,#F8,#E1
db #E3,#3C,#E1,#3E,#C7,#7C,#E1,#3E,#BE,#8F,#C3,#F0,#E1
db #E3,#7C,#E1,#3E,#87,#F8,#F0,#F0,#96,#2F,#CB,#F0,#E1
db #E3,#3F,#8F,#3E,#8F,#F0,#F0,#F0,#96,#2D,#4B,#F0,#E1
db #E3,#0F,#0F,#F8,#87,#F8,#F0,#F0,#97,#6D,#5F,#F0,#E1
db #E3,#3C,#F0,#F0,#87,#F8,#F1,#7E,#C7,#7D,#1F,#F0,#E1
db #E3,#3C,#F0,#F0,#C7,#7C,#E3,#3C,#C7,#79,#1E,#F0,#E1
db #E3,#3C,#F0,#F0,#E3,#0F,#0F,#7C,#C3,#78,#1E,#F0,#E1
db #F3,#FC,#F0,#F0,#F0,#C7,#3F,#F0,#E3,#F8,#BE,#F0,#E1


;==============================================================================
;### TRANSFER AREA ############################################################
;==============================================================================

prgtrnbeg
;### PRGPRZS -> Stack for application process
        ds 128
prgstk  ds 6*2
        dw prgprz
prgprzn db 0
prgmsgb ds 14

cfgcpctyp   db 0

;### SYMBOS INFO ##############################################################

syswininf   dw #1501,0,75,02,170,170,0,0,170,170,170,170,170,170,systiticn,systitinft,0,0,sysgrpinf,0,0:ds 136+14
sysgrpinf   db 11,0:dw sysdatinf,0,0,11*256+11,0,0,11
sysdatinf
dw 00,255*256+0 ,2,           0, 0,1000,1000,0         ;00 Background
dw 00,255*256+8, syslogo,    05, 1,   160,16,0         ;01 Logo
dw 00,255*256+1 ,systxtinf1, 05,17+ 5,160, 8,0         ;02 Description 1
dw 00,255*256+1 ,systxtinf2, 05,17+13,160, 8,0         ;03 Description 2
dw 00,255*256+1 ,systxtinf3, 05,17+25,160, 8,0         ;04 Description 3
dw 00,255*256+1 ,systxtinf4, 05,17+37,160, 8,0         ;05 Description 4
dw 00,255*256+1 ,systxtinf5, 05,17+45,160, 8,0         ;06 Description 5
dw 00,255*256+2 ,4*1+3     , 04,17+56,162,66,0         ;07 Greetings frame
dw 00,255*256+25,sysobjsup , 05,17+57,160,64,0         ;08 Greetings window
dw 00,255*256+1 ,systxtinf9, 05,57+85,160, 8,0         ;09 Description 9
dw prgend,255*256+16,sysbutok  , 60,57+97,50,12,0      ;10 "Ok"-Button

systxtinf1  dw systxtinf1t,4*3+2+512
systxtinf2  dw systxtinf2t,4*3+2+512
systxtinf3  dw systxtinf3t,4*0+3+512+128
systxtinf4  dw systxtinf4t,4*1+2+512
systxtinf5  dw systxtinf5t,4*1+2+512
systxtinf9  dw systxtinf9t,4*3+2+512

;Greetings-Subfenster
sysobjsup   dw sysgrpwin,152,190,0,0,2
sysgrpwin   db 24,0:dw sysdatwin,0,0,00*256+00,0,0,00
sysdatwin
dw 00,255*256+0 ,0,           0, 0,1000,1000,0         ;?? Background
dw 00,255*256+1 ,sysobjsub00,01,8*00+1,158, 8,0        ;?? Title 1
dw 00,255*256+0 ,3,          01,8*00+10,158,1,0        ;?? Line 1
dw 00,255*256+1 ,sysobjsub10,01,8*01+5,158, 8,0        ;?? Description
dw 00,255*256+1 ,sysobjsub11,11,8*02+5,158, 8,0        ;?? Description
dw 00,255*256+1 ,sysobjsub20,01,8*03+5,158, 8,0        ;?? Description
dw 00,255*256+1 ,sysobjsub21,11,8*04+5,158, 8,0        ;?? Description
dw 00,255*256+1 ,sysobjsub30,01,8*05+5,158, 8,0        ;?? Description
dw 00,255*256+1 ,sysobjsub31,11,8*06+5,158, 8,0        ;?? Description
dw 00,255*256+1 ,sysobjsub40,01,8*07+14,158, 8,0       ;?? Title 2
dw 00,255*256+0 ,3,          01,8*07+23,158,1,0        ;?? Line 2
dw 00,255*256+1 ,sysobjsub50,01,8*08+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub51,11,8*09+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub90,01,8*10+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub91,11,8*11+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub92,11,8*12+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub60,01,8*13+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub61,11,8*14+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub70,01,8*15+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub71,11,8*16+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub80,01,8*17+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsub81,11,8*18+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsuba0,01,8*19+19,158, 8,0       ;?? Description
dw 00,255*256+1 ,sysobjsuba1,11,8*20+19,158, 8,0       ;?? Description

sysobjsub00 dw systxtsub00,4*1+0+512
sysobjsub10 dw systxtsub10,4*1+0
sysobjsub11 dw systxtsub11,4*3+0
sysobjsub20 dw systxtsub20,4*1+0
sysobjsub21 dw systxtsub21,4*3+0
sysobjsub30 dw systxtsub30,4*1+0
sysobjsub31 dw systxtsub31,4*3+0
sysobjsub40 dw systxtsub40,4*1+0+512
sysobjsub50 dw systxtsub50,4*1+0
sysobjsub51 dw systxtsub51,4*3+0
sysobjsub60 dw systxtsub60,4*1+0
sysobjsub61 dw systxtsub61,4*3+0
sysobjsub70 dw systxtsub70,4*1+0
sysobjsub71 dw systxtsub71,4*3+0
sysobjsub80 dw systxtsub80,4*1+0
sysobjsub81 dw systxtsub81,4*3+0
sysobjsub90 dw systxtsub90,4*1+0
sysobjsub91 dw systxtsub91,4*3+0
sysobjsub92 dw systxtsub92,4*3+0
sysobjsuba0 dw systxtsuba0,4*1+0
sysobjsuba1 dw systxtsuba1,4*3+0

prgtrnend

relocate_table
relocate_end
