;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@              S Y M B i F A C E   I I   R o m - M a n a g e r               @
;@                                                                            @
;@             (c) 2004-2007 by Prodatron / SymbiosiS (Jrn Mika)             @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

relocate_start

;- rom detection

real_mode equ 1


;==============================================================================
;### CODE-TEIL ################################################################
;==============================================================================

;### PROGRAMM-KOPF ############################################################

prgdatcod       equ 0           ;Lnge Code-Teil (Pos+Len beliebig; inklusive Kopf!)
prgdatdat       equ 2           ;Lnge Daten-Teil (innerhalb 16K Block)
prgdattra       equ 4           ;Lnge Transfer-Teil (ab #C000)
prgdatorg       equ 6           ;Original-Origin
prgdatrel       equ 8           ;Anzahl Eintrge Relocator-Tabelle
prgdatstk       equ 10          ;Lnge Stack (Transfer-Teil beginnt immer mit Stack)
prgdatcrn       equ 12          ;Lnge gecrunchte Daten
prgdatctp       equ 14          ;Crunch-Typ (0=ungepackt, 1=SymbOS, 2=eigene Routine)
prgdatnam       equ 15          ;Programm-Name (32+1[0] Zeichen)
prgdatidn       equ 48          ;"SymExe10"
prgdatres       equ 56          ;*reserviert* (34 bytes)
prgdatism       equ 90          ;Icon (klein)
prgdatibg       equ 109         ;Icon (gross)
prgdatlen       equ 256         ;Datensatzlnge

prgpstdat       equ 6           ;Adresse Daten-Teil
prgpsttra       equ 8           ;Adresse Transfer-Teil
prgpstspz       equ 10          ;zustzliche Prozessnummern (4*1)
prgpstbnk       equ 14          ;Bank (1-8)
prgpstmem       equ 48          ;zustzliche Memory-Bereiche (8*5)
prgpstnum       equ 88          ;Programm-Nummer
prgpstprz       equ 89          ;Prozess-Nummer

prgcodbeg   dw prgdatbeg-prgcodbeg  ;Lnge Code-Teil
            dw prgtrnbeg-prgdatbeg  ;Lnge Daten-Teil
            dw prgtrnend-prgtrnbeg  ;Lnge Transfer-Teil
prgdatadr   dw #1000                ;Original-Origin                    POST Adresse Daten-Teil
prgtrnadr   dw relocate_count       ;Anzahl Eintrge Relocator-Tabelle  POST Adresse Transfer-Teil
prgprztab   dw prgstk-prgtrnbeg     ;Lnge Stack                        POST Tabelle Prozesse
            dw 0                    ;Lnge gecrunchte Daten
prgbnknum   db 0                    ;Crunch-Typ                         POST Bank-Nummer
            db "SYMBiFACE II Rom Manager":ds 8:db 0   ;Name
prgmemtab   db "SymExe10"           ;SymbOS-EXE-Kennung                 POST Tabelle Speicherbereiche
            dw 0                    ;zustzlicher Code-Speicher
            dw 33*24+1024           ;zustzlicher Data-Speicher
            dw 8192+256             ;zustzlicher Transfer-Speicher
            ds 28                   ;*reserviert*
prgicnsml   db 2,8,8,#75,#EA,#38,#C1,#74,#E2,#29,#C1,#74,#6A,#38,#C1,#74,#E2,#08,#01
prgicnbig   db 6,24,24
            db #00,#00,#00,#72,#00,#00,#00,#00,#00,#74,#80,#00,#00,#00,#10,#F8,#C0,#00,#00,#00,#11,#F0,#E0,#00,#00,#00,#72,#F0,#F0,#00,#00,#00,#74,#D2,#F0,#80,#00,#10,#F8,#A5,#F0,#88,#00,#11,#F0,#78,#F1,#C4
            db #00,#72,#E1,#B4,#F3,#48,#00,#74,#C3,#78,#F5,#40,#10,#F8,#A5,#F0,#DE,#40,#11,#F0,#78,#F1,#D4,#44,#72,#F0,#B4,#F3,#58,#00,#70,#F0,#F0,#F5,#51,#00,#72,#F6,#F0,#DE,#40,#00,#73,#F6,#F1,#D4,#44,#00
            db #53,#F8,#F3,#58,#00,#00,#45,#FC,#F5,#51,#00,#00,#00,#7E,#DE,#40,#00,#00,#00,#37,#D4,#44,#00,#00,#00,#13,#58,#00,#00,#00,#00,#01,#51,#00,#00,#00,#00,#00,#40,#00,#00,#00,#00,#00,#44,#00,#00,#00

;### PRGPRZ -> Programm-Prozess
dskprzn     db 2
sysprzn     db 3
windatprz   equ 3   ;Prozenummer
windatsup   equ 51  ;Nummer des Superfensters+1 oder 0
prgwin      db 0    ;Nummer des Haupt-Fensters
diawin      db 0    ;Nummer des Dialog-Fensters

prgprz  ld a,(prgprzn)
        ld (prgwindat+windatprz),a
        ld (confrmwin+windatprz),a

        call romini

        ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,prgwindat
        call msgsnd             ;Fenster aufbauen
prgprz1 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        jp z,prgend             ;kein Speicher fr Fenster -> Proze beenden
        cp MSR_DSK_WOPNOK
        jr nz,prgprz1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (prgwin),a           ;Fenster wurde geffnet -> Nummer merken

        call romsel1

prgprz0 call msgget
        jr nc,prgprz0
        cp MSR_SYS_SELOPN       ;*** Browse-Fenster wurde geschlossen
        jp z,prgbrc
        cp MSR_DSK_WCLICK       ;*** Fenster-Aktion wurde geklickt
        jr nz,prgprz0
        ld a,(iy+2)             ;*** HAUPT-FENSTER
        cp DSK_ACT_CLOSE        ;*** Close wurde geklickt
        jp z,prgend
        cp DSK_ACT_KEY          ;*** Taste wurde gedrckt
        jr z,prgkey
        cp DSK_ACT_CONTENT      ;*** Inhalt wurde geklickt
        jr nz,prgprz0
prgprz2 ld l,(iy+8)
        ld h,(iy+9)
        ld a,h
        or l
        jr z,prgprz0
        ld a,(iy+3)             ;A=Klick-Typ (0/1/2=Maus links/rechts/doppelt, 7=Tastatur)
        jp (hl)

;### PRGKEY -> Taste auswerten
prgkeya equ 4
prgkeyt db "L":dw romlod    ;L=Rom laden
        db "S":dw romsav    ;S=Rom speichern
        db 008:dw romdel    ;Del=Rom lschen
        db 127:dw romdel    ;Clr=Rom lschen

prgkey  ld hl,prgkeyt
        ld b,prgkeya
        ld de,3
        ld a,(iy+4)
        call clcucs
prgkey1 cp (hl)
        jr z,prgkey2
        add hl,de
        djnz prgkey1
        jp prgprz0
prgkey2 inc hl
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ld a,7
        jp (hl)

;### PRGEND -> Programm beenden
prgend  ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        ld (iy+0),MSC_SYS_PRGEND
        ld a,(prgcodbeg+prgpstnum)
        ld (iy+1),a
        rst #10
prgend0 rst #30
        jr prgend0

;### PRGINF -> Info-Fenster anzeigen
prginf  ld hl,prgmsginf         ;*** Info-Fenster
        ld b,1+128
        call prginf0
        jp prgprz0
prginf0 ld (prgmsgb+1),hl
        ld a,(prgbnknum)
        ld c,a
        ld (prgmsgb+3),bc
        ld a,MSC_SYS_SYSWRN
        ld (prgmsgb),a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        rst #10
        ret


;==============================================================================
;### SUB-ROUTINEN #############################################################
;==============================================================================

;### MSGGET -> Message fr Programm abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgget  ld a,(prgprzn)
        db #dd:ld l,a           ;IXL=Rechner-Proze-Nummer
        db #dd:ld h,-1
        ld iy,prgmsgb           ;IY=Messagebuffer
msgget1 rst #08                 ;Message holen -> IXL=Status, IXH=Absender-Proze
        or a
        db #dd:dec l
        ret nz
        ld iy,prgmsgb
        ld a,(iy+0)
        or a
        jp z,prgend
        scf
        ret

;### MSGDSK -> Message fr Programm von Deskzop-Prozess abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgdsk  call msgget
        jr nc,msgdsk            ;keine Message
        ld a,(dskprzn)
        db #dd:cp h
        jr nz,msgdsk            ;Message von anderem als Desktop-Proze -> ignorieren
        ld a,(prgmsgb)
        ret

;### MSGSND -> Message an Desktop-Prozess senden
;### Eingabe    C=Kommando, B/E/D/L/H=Parameter1/2/3/4/5
msgsnd0 ld a,(prgwin)
        ld b,a
msgsnd2 ld c,MSC_DSK_WININH
msgsnd  ld a,(dskprzn)
msgsnd1 db #dd:ld h,a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),b
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        rst #10
        ret

;### SYSCLL -> Betriebssystem-Funktion aufrufen
;### Eingabe    (SP)=Modul/Funktion, AF,BC,DE,HL,IX,IY=Register
;### Ausgabe    AF,BC,DE,HL,IX,IY=Register
sysclln db 0
syscll  ld (prgmsgb+04),bc      ;Register in Message-Buffer kopieren
        ld (prgmsgb+06),de
        ld (prgmsgb+08),hl
        ld (prgmsgb+10),ix
        ld (prgmsgb+12),iy
        push af
        pop hl
        ld (prgmsgb+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (prgmsgb+00),de      ;Modul und Funktion in Message-Buffer kopieren
        ld a,e
        ld (sysclln),a
        ld iy,prgmsgb
        ld a,(prgprzn)          ;Desktop und System-Prozessnummer holen
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        rst #10                 ;Message senden
syscll1 rst #30
        ld iy,prgmsgb
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        rst #18                 ;auf Antwort warten
        db #dd:dec l
        jr nz,syscll1
        ld a,(prgmsgb)
        sub 128
        ld e,a
        ld a,(sysclln)
        cp e
        jr nz,syscll1
        ld hl,(prgmsgb+02)      ;Register aus Message-Buffer holen
        push hl
        pop af
        ld bc,(prgmsgb+04)
        ld de,(prgmsgb+06)
        ld hl,(prgmsgb+08)
        ld ix,(prgmsgb+10)
        ld iy,(prgmsgb+12)
        ret

;### CLCN32 -> Wandelt 32Bit-Zahl in ASCII-String um (mit 0 abgeschlossen)
;### Eingabe    DE,IX=Wert, IY=Adresse
;### Ausgabe    IY=Adresse letztes Zeichen
;### Veraendert AF,BC,DE,HL,IX,IY
clcn32t dw 1,0,     10,0,     100,0,     1000,0,     10000,0
        dw #86a0,1, #4240,#f, #9680,#98, #e100,#5f5, #ca00,#3b9a
clcn32z ds 4

clcn32  ld (clcn32z),ix
        ld (clcn32z+2),de
        ld ix,clcn32t+36
        ld b,9
        ld c,0
clcn321 ld a,"0"
        or a
clcn322 ld e,(ix+0):ld d,(ix+1):ld hl,(clcn32z):  sbc hl,de:ld (clcn32z),hl
        ld e,(ix+2):ld d,(ix+3):ld hl,(clcn32z+2):sbc hl,de:ld (clcn32z+2),hl
        jr c,clcn325
        inc c
        inc a
        jr clcn322
clcn325 ld e,(ix+0):ld d,(ix+1):ld hl,(clcn32z):  add hl,de:ld (clcn32z),hl
        ld e,(ix+2):ld d,(ix+3):ld hl,(clcn32z+2):adc hl,de:ld (clcn32z+2),hl
        ld de,-4
        add ix,de
        inc c
        dec c
        jr z,clcn323
        ld (iy+0),a
        inc iy
clcn323 djnz clcn321
        ld a,(clcn32z)
        add "0"
        ld (iy+0),a
        ld (iy+1),0
        ret

;### CLCUCS -> Wandelt Klein- in Grobuchstaben um
;### Eingabe    A=Zeichen
;### Ausgabe    A=ucase(Zeichen)
;### Verndert  F
clcucs  cp "a"
        ret c
        cp "z"+1
        ret nc
        add "A"-"a"
        ret


;==============================================================================
;### PRESET ROUTINEN ##########################################################
;==============================================================================

;### PREOPN -> Preset-Verwaltung ffnen
preopn  ;...
        jp prgprz0



;==============================================================================
;### FILE-BROWSER #############################################################
;==============================================================================

;### PRGBRO -> Browse-Fenster ffnen
;### Eingabe    A=Typ (1=Load Rom, 2=Save Rom), HL=Maske/Pfad
prgbron db 0
prgbro  ld e,a
        ld a,(prgbron)
        or a
        ret nz
        ld a,e
        ld (prgbron),a
        ld (prgmsgb+8),hl
        ld hl,(prgbnknum)
        ld h,8
        ld (prgmsgb+6),hl
        ld hl,1000
        ld (prgmsgb+10),hl
        ld hl,16384
        ld (prgmsgb+12),hl
        ld l,MSC_SYS_SELOPN
        ld (prgmsgb),hl
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        rst #10
        ret

;### PRGBRC -> Browse-Fenster schlieen
;### Eingabe    P1=Typ (0=Ok, 1=Abbruch, 2=FileAuswahl bereits in Benutzung, 3=kein Speicher frei, 4=kein Fenster frei), P2=PfadLnge
prgbrc  ld a,(prgmsgb+1)
        inc a
        jr nz,prgbrc0
        ld a,(prgmsgb+2)
        ld (prgwindat+windatsup),a
        jp prgprz0
prgbrc0 ld hl,prgbron
        ld e,(hl)
        ld (hl),0
        dec a
        jp nz,prgprz0
        dec e               ;ZF=1 load, ZF=0 save
        jp z,romlod1
        jp romsav1


;==============================================================================
;### ROM ROUTINEN (CODE) ######################################################
;==============================================================================

;### ROMINI -> Rom-Liste generieren
romini  xor a
        ld (romlstobj+12),a
        ld b,64             ;RSX-Listenzeiger initialisieren
        ld ix,rsxlstlst
        ld hl,romnamtxt
        ld de,33*24
        add hl,de
romini9 ld (ix+0),0
        ld (ix+1),0
        ld (ix+2),l
        ld (ix+3),h
        ld de,4
        add ix,de
        ld de,16
        add hl,de
        djnz romini9
        ld b,32             ;ROM-Listenzeiger initialisieren
        ld ix,romlstlst
        ld hl,romnamtxt
romini1 xor a
        ld (ix+0),a
        ld (ix+1),a
        ld a,32
        sub b
        jr nz,romini8
        ld (ix+1),128
romini8 ld (ix+4),a
        ld (ix+2),l
        ld (ix+3),h
        ld de,16
        add hl,de
        ld (ix+6),l
        ld (ix+7),h
        ld de,8
        add hl,de
        add ix,de
        djnz romini1
        ld hl,romnamtxt     ;Namen und Versionen lschen
        ld de,romnamtxt+1
        ld bc,32*24
        ld (hl),0
        ldir
        ld b,32             ;Rom-Namen holen
        ld de,romnamtxt
romini2 push bc
        push de
        ld a,32
        sub b
        ld hl,#c000
        ld bc,6
        push af
        call romget
        pop bc
        ld ix,rombuf
        ld a,(ix+0)
        ld hl,romnamtxt2
        cp #80
        jr z,romini3
        or a
        jr z,romini3        ;#00 oder #80 -> nicht untersttztes Vordergrund-Rom
        ld hl,romnamtxt1
        cp 2
        jr z,romini3        ;#02 -> Expansion Rom
        ld hl,romnamtxt0
        cp #ff
        jr z,romini3        ;#FF -> leeres Rom
        ld hl,romnamtxt3
        dec a
        jr nz,romini3       ;kein #01 -> korruptes Rom
        pop de
        push de
        push bc
        push de
        ld iy,16            ;Version holen
        add iy,de
        ld a,(ix+1)
        call romini4
        ld (iy+0),"."
        inc iy
        ld a,(ix+2)
        call romini4
        ld a,(ix+3)
        call romini4
        pop iy
        ld (iy+23),0
        pop af
        ld l,(ix+4)
        ld h,(ix+5)
        ld bc,15
        call romget
        ld hl,rombuf        ;Namen holen
romini3 pop de
        push de
        ld b,15
romini5 ld a,(hl)
        ld (de),a
        rla
        jr c,romini6
        inc hl
        inc de
        djnz romini5
        jr romini7
romini6 ex de,hl
        res 7,(hl)
romini7 pop de
        ld hl,16+8
        add hl,de
        ex de,hl
        pop bc
        dec b
        jp nz,romini2
        ret
romini4 push ix
        db #dd:ld l,a
        db #dd:ld h,0
        ld de,0
        call clcn32
        inc iy
        pop ix
        ret

;### ROMSEL -> User hat Rom ausgewhlt
romsel  cp 2
        jp z,romlod
        push af
        call romsel1
        pop af
        dec a
        jp z,romsav
        jp prgprz0
romsel1 xor a
        ld (rsxlstobj+2),a
        ld hl,romnamtxt
        ld de,33*24
        add hl,de
        ld e,l
        ld d,h
        inc de
        ld (hl),a
        ld bc,64*16-1
        ldir
        ld a,(romlstobj+12)
        ld hl,#c000
        ld bc,6
        call romget
        ld ix,rombuf
        ld a,(ix+0)
        cp 1
        jr z,romsel7
        cp 2
        ld b,64
        jr nz,romsel2       ;leeres oder nicht untersttztes Rom
romsel7 ld l,(ix+4)
        ld h,(ix+5)
        ld bc,1024
        ld a,(romlstobj+12)
        call romget
        ld hl,romnamtxt
        ld de,33*24
        add hl,de
        ex de,hl
        ld hl,rombuf
        ld b,64
romsel3 ld a,(hl)
        or a
        jr z,romsel2
        push de
        ld c,15
romsel4 ld a,(hl)
        inc hl
        bit 7,a
        jr nz,romsel6
        cp 32
        jr c,romsel4
        ld (de),a
        inc de
        dec c
        jr nz,romsel4
        jr romsel5
romsel6 res 7,a
        cp 32
        jr c,romsel5
        ld (de),a
romsel5 ex (sp),hl
        ld de,16
        add hl,de
        ex de,hl
        pop hl
        djnz romsel3
romsel2 ld a,64
        sub b
        ld (rsxlstobj),a
        ld e,2
        call msgsnd0
        jp prgprz0

;### ROMLOD -> Rom von Diskette in SF2 laden
romhnd  db 0
romnum  db 0

romlod  ld a,1
romlod0 ld hl,rompth
        call prgbro
        ld a,(romlstobj+12)
        ld (romnum),a
        jp prgprz0
romlod1 ld a,(prgbnknum)    ;*** Rom ffnen
        db #dd:ld h,a
        ld hl,rompth1
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOPN
        jp c,prgprz0
        ld (romhnd),a
        ld hl,rombuf        ;*** Test, ob Header vorhanden
        ld de,(prgbnknum)
        ld bc,128
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        ld ix,rombuf
        ld b,67
        ld hl,0
        ld d,l
romlod2 ld e,(ix+0)
        inc ix
        add hl,de
        djnz romlod2
        ld de,(rombuf+67)
        or a
        sbc hl,de
        jr z,romlod3
        ld c,0              ;*** Nein -> nicht berspringen
        ld a,(romhnd)
        ld ix,0
        ld iy,0
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILPOI
romlod3 ld b,4              ;*** Rom laden
        ld hl,#c000
romlod4 push bc
        push hl
        ld a,(romhnd)
        ld hl,rombuf
        ld de,(prgbnknum)
        ld bc,4096
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        pop de
        push de
        ld bc,4096
        ld a,(romnum)
        call romput
        pop hl
        ld de,4096
        add hl,de
        pop bc
        djnz romlod4
        ld a,(romhnd)
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
        jp romdel4

;### ROMSAV -> Rom von SF2 auf Diskette speichern
romsav  ld a,2
        jp romlod0
romsav1 ld a,(prgbnknum)    ;*** Rom ffnen
        db #dd:ld h,a
        ld hl,rompth1
        xor a
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILNEW
        jp c,prgprz0
        ld (romhnd),a
        ld b,4              ;*** Rom speichern
        ld hl,#c000
romsav2 push bc
        push hl
        ld bc,4096
        ld a,(romnum)
        call romget
        ld a,(romhnd)
        ld hl,rombuf
        ld de,(prgbnknum)
        ld bc,4096
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOUT
        pop hl
        ld de,4096
        add hl,de
        pop bc
        djnz romsav2
        ld a,(romhnd)
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
        jp prgprz0

;### ROMDEL -> Rom im SF2 lschen
romdel  ld a,(romlstobj+12)
        ld (romnum),a
        ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,confrmwin
        call msgsnd             ;Fenster aufbauen
romdel2 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        jp z,prgprz0            ;kein Speicher fr Fenster -> Proze beenden
        cp MSR_DSK_WOPNOK
        jr nz,romdel2           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (diawin),a           ;Fenster wurde geffnet -> Nummer merken
        inc a
        ld (prgwindat+windatsup),a
        jp prgprz0
romdel0 call romdel3            ;** Cancel
        jp prgprz0
romdel3 ld c,MSC_DSK_WINCLS     ;Dialog-Fenster schliessen
        ld a,(diawin)
        ld b,a
        jp msgsnd
romdel1 call romdel3            ;** OK
        ld a,-1
        ld (rombuf),a
        ld a,(romnum)
        ld de,#c000
        ld bc,1
        call romput
romdel4 call romini
        ld e,1
        call msgsnd0
        call romsel1
        jp prgprz0

;Rom-Dummy fr Emulator-Version
romsim  db 1,0,3,2      ;ROM-Kennung und Version
        dw #c000+6      ;Zeiger auf RSX-Namen
        db "SYMBOS 0.3","A"+#80
        db "SYM","A"+#80
        db "SY","M"+#80
        db "SYMBO","S"+#80
        db 0

;### ROMGET -> Bereich aus Rom herauskopieren
;### Eingabe    HL=Quelle (ab #c000), BC=Lnge, A=Rom-Nummer (0-31)
;### Ausgabe    (rombuf)=Speicher
;### Verndert  AF,BC,DE,HL
romget
if real_mode
        ld de,#8000
        add hl,de       ;HL=umgerechnete Quell-Adresse
        ld de,#8000+romgetz-romgetx
        jp romget0
else
        ld a,-#c0
        add h
        ld h,a
        ld de,romsim
        add hl,de
        ld de,rombuf
        ldir
        ret
endif

;### ROMPUT -> Bereich in Rom hineinkopieren
;### Eingabe    (rombuf)=Speicher, DE=Ziel (ab #c000), BC=Lnge, A=Rom-Nummer (0-31)
;### Verndert  AF,BC,DE,HL
romput
if real_mode
        ld hl,#8000
        add hl,de
        ex de,hl        ;DE=umgerechnete Ziel-Adresse
        ld hl,#8000+romgetz-romgetx
        jp romget0
else
        ret
endif


;==============================================================================
;### DATEN-TEIL ###############################################################
;==============================================================================

prgdatbeg

;### Verschiedenes
prgmsginf1 db "SYMBiFACE II Rom Manager",0
prgmsginf2 db " Version 1.2 (Build 061107pdt)",0
prgmsginf3 db " Copyright <c> 2006 SymbiosiS",0

prgwintit   db "SYMBiFACE II Rom Manager 1.2",0

prgtxtok    db "Ok",0
prgtxtcnc   db "Cancel",0
prgtxtyes   db "Yes",0
prgtxtno    db "No",0

confrmtxt0  db "Remove Rom",0
confrmtxt1  db "Do you really want to delete the",0
confrmtxt2  db "selected ROM?",0

;### Haupt-Fenster-Texte
prgobjtxt1  db "Load",0
prgobjtxt2  db "Save",0
prgobjtxt3  db "Delete",0
prgobjtxt4  db "Presets",0
prgobjtxt5  db "About",0
prgobjtxt6  db "Quit",0

romtittxta  db "Name",0
romtittxtb  db "#",0
romtittxtc  db "Version",0
rsxtittxt   db "RSX commands",0

romnamtxt0 db " [--empty--","]"+#80         ;#ff
romnamtxt1 db "+expansion rom","+"+#80      ;#02
romnamtxt2 db "!not supported","!"+#80      ;#00, #80
romnamtxt3 db "!corrupt","!"+#80            ;sonstige auer #01

romnamtxt   ds 2            ;### LETZTER LABEL ###


;==============================================================================
;### TRANSFER-TEIL ############################################################
;==============================================================================

prgtrnbeg
;### PRGPRZS -> Stack fr Programm-Prozess
        ds 128
prgstk  ds 6*2
        dw prgprz
prgprzn db 0
prgmsgb ds 14

;### BESTTIGUNGS FENSTER #####################################################

confrmwin   dw #1401,4+16,079,062,160,46,0,0,160,46,160,46,160,46,0,confrmtxt0,0,0,confrmgrp,0,0:ds 136+14
confrmgrp   db 5,0:dw confrmdat,0,0,256*5+4,0,0,00
confrmdat
dw      00,         0,2,        0,0,1000,1000,0         ;00=Hintergrund
dw      00,255*256+ 1,confrmdsc1,05,05,150, 8,0         ;01=Beschreibung1
dw      00,255*256+ 1,confrmdsc2,05,15,150, 8,0         ;02=Beschreibung2
dw romdel1,255*256+16,prgtxtyes, 31,29, 48,12,0         ;03="Yes"-Button
dw romdel0,255*256+16,prgtxtno , 81,29, 48,12,0         ;04="No" -Button

confrmdsc1  dw confrmtxt1,2+4
confrmdsc2  dw confrmtxt2,2+4

;### HAUPT-FENSTER ############################################################

prgwindat dw #1701,3,30,10,250,150,0,0,250,150,200,100,1000,1000,prgicnsml,prgwintit,0,00,prgwingrp,0,0:ds 136+14

prgwingrp db 9,0:dw prgwinobj,prgwinclc,0,0,0,0,2
prgwinobj
dw     00,255*256+00,2         ,0,0,0,0,0   ;00=Hintergrund
dw romsel,255*256+43,romlstobj ,0,0,0,0,0   ;01=Rom-Liste
dw     00,255*256+43,rsxlstobj ,0,0,0,0,0   ;02=Rsx-Liste
dw romlod,255*256+16,prgobjtxt1,0,0,0,0,0   ;03=Button "Load"
dw romsav,255*256+16,prgobjtxt2,0,0,0,0,0   ;04=Button "Save"
dw romdel,255*256+16,prgobjtxt3,0,0,0,0,0   ;05=Button "Delete"
dw preopn,255*256+16,prgobjtxt4,0,0,0,0,0   ;06=Button "Presets"
dw prginf,255*256+16,prgobjtxt5,0,0,0,0,0   ;07=Button "About"
dw prgend,255*256+16,prgobjtxt6,0,0,0,0,0   ;08=Button "Quit"
prgwinclc
dw   0,0,0,0,1000,0,1000,0
dw   1,      0,  1,  0, -2,256*8+5,-15,257
dw   0,256*8+5,  1,  0, -1,256*8+3,-15,257
dw   1,256*6+0,-13,257, -2,256*6+1, 12,  0
dw   0,256*6+1,-13,257, -1,256*6+1, 12,  0
dw   0,256*6+2,-13,257, -1,256*6+1, 12,  0
dw   0,256*6+3,-13,257, -1,256*6+1, 12,  0
dw   0,256*6+4,-13,257, -1,256*6+1, 12,  0
dw   0,256*6+5,-13,257, -1,256*6+1, 12,  0

romlstobj   dw 32,0,romlstlst,0,3,romlstrow,0,1
romlstrow   dw 0,100,romtittxta,0, 2+8,12,romtittxtb,0, 2,37,romtittxtc,0
romlstlst   ds 32*8

rsxlstobj   dw 0,0,rsxlstlst,0,1,rsxlstrow,0,1
rsxlstrow   dw 0,1000,rsxtittxt,0
rsxlstlst   ds 64*4


rompth  db "rom",0
rompth1 ds 256

;### INFO-FENSTER #############################################################

prgmsginf  dw prgmsginf1,4*1+2,prgmsginf2,4*1+2,prgmsginf3,4*1+2,prgicnbig


;==============================================================================
;### ROM-ROUTINE (BANKING) ####################################################
;==============================================================================

romget0 ld (romgets+1),hl
        ld (romgetd+1),de
        db #dd:ld l,c
        db #dd:ld h,b
        ld iy,romgetz-romgetx
        add iy,bc
        ld bc,#df00
        out (c),a       ;Rom auswhlen
        ld b,#7f
        ld a,i
        and #f8
        or 1
        di
        out (c),a       ;in erste Ram-Bank wechseln
        ld hl,rombuf
        ld de,4096
        add hl,de
        ex de,hl
        ld hl,#8000
        db #fd:ld c,l
        db #fd:ld b,h
        ldir            ;Betriebssystem-Code sichern
        ld hl,romgetx
        ld de,#8000
        ld bc,romgetz-romgetx
        ldir
        ld hl,rombuf    ;Daten setzen
        ld de,#8000+romgetz-romgetx
        db #dd:ld c,l
        db #dd:ld b,h
romget3 ldir
        jp #8000
romget2 ld de,rombuf    ;Daten holen
        ld hl,#8000+romgetz-romgetx
        db #dd:ld c,l
        db #dd:ld b,h
romget4 ldir
        ld hl,rombuf
        ld de,4096
        add hl,de
        ld de,#8000
        db #fd:ld c,l
        db #fd:ld b,h
        ldir            ;Betriebssystem-Code wiederherstellen
        ld a,i
        ld b,#7f
        out (c),a       ;zurck in Application-Bank wechseln
        ei
        ret
romgetx ld bc,#fd17     ;Rom ab #4000 einblenden
        in a,(c)
        db #dd:ld c,l
        db #dd:ld b,h
romgets ld hl,0
romgetd ld de,0
        ldir
        ld bc,#fd17
        out (c),a
        jp romget2
romgetz

rombuf  db 0            ;### letzter label ###

prgtrnend

relocate_table
relocate_end
