;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                                S p e e c h                                 @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


;==============================================================================
;### CODE-TEIL ################################################################
;==============================================================================

;### PROGRAMM-KOPF ############################################################

prgdatcod       equ 0           ;Lnge Code-Teil (Pos+Len beliebig; inklusive Kopf!)
prgdatdat       equ 2           ;Lnge Daten-Teil (innerhalb 16K Block)
prgdattra       equ 4           ;Lnge Transfer-Teil (ab #C000)
prgdatorg       equ 6           ;Original-Origin
prgdatrel       equ 8           ;Anzahl Eintrge Relocator-Tabelle
prgdatstk       equ 10          ;Lnge Stack (Transfer-Teil beginnt immer mit Stack)
prgdatcrn       equ 12          ;Lnge gecrunchte Daten
prgdatctp       equ 14          ;Crunch-Typ (0=ungepackt, 1=SymbOS, 2=eigene Routine)
prgdatnam       equ 15          ;Programm-Name (32+1[0] Zeichen)
prgdatidn       equ 48          ;"SymExe10"
prgdatcex       equ 56          ;zustzlicher Speicher fr Code-Bereich
prgdatdex       equ 58          ;zustzlicher Speicher fr Data-Bereich
prgdattex       equ 60          ;zustzlicher Speicher fr Transfer-Bereich
prgdatres       equ 62          ;*reserviert* (28 bytes)
prgdatism       equ 90          ;Icon (klein)
prgdatibg       equ 109         ;Icon (gross)
prgdatlen       equ 256         ;Datensatzlnge

prgpstdat       equ 6           ;Adresse Daten-Teil
prgpsttra       equ 8           ;Adresse Transfer-Teil
prgpstspz       equ 10          ;zustzliche Prozessnummern (4*1)
prgpstbnk       equ 14          ;Bank (1-8)
prgpstmem       equ 48          ;zustzliche Memory-Bereiche (8*5)
prgpstnum       equ 88          ;Programm-Nummer
prgpstprz       equ 89          ;Prozess-Nummer

prgcodbeg   dw prgdatbeg-prgcodbeg  ;Lnge Code-Teil
            dw prgtrnbeg-prgdatbeg  ;Lnge Daten-Teil
            dw prgtrnend-prgtrnbeg  ;Lnge Transfer-Teil
prgdatadr   dw #1000                ;Original-Origin                    POST Adresse Daten-Teil
prgtrnadr   dw 0                    ;Anzahl Eintrge Relocator-Tabelle  POST Adresse Transfer-Teil
prgprztab   dw prgstk-prgtrnbeg     ;Lnge Stack                        POST Tabelle Prozesse
            dw 0                    ;Lnge gecrunchte Daten
prgbnknum   db 0                    ;Crunch-Typ                         POST Bank-Nummer
            db "Speech":ds 26:db 0  ;Name
prgmemtab   db "SymExe10"           ;SymbOS-EXE-Kennung                 POST Tabelle Speicherbereiche
            dw 0                    ;zustzlicher Code-Speicher
            dw 0                    ;zustzlicher Data-Speicher
            dw 0                    ;zustzlicher Transfer-Speicher
            ds 28                   ;*reserviert*
prgicnsml   db 2,8,8,#2F,#4F,#F7,#FE,#88,#11,#F8,#F1,#FC,#F3,#CC,#33,#7F,#EF,#3F,#CF
prgicnbig   db 6,24,24
            db #F0,#F0,#F0,#F0,#C0,#00,#87,#0F,#69,#1E,#C0,#E0,#87,#0F,#0F,#0F,#2C,#E0,#87,#0F,#0F,#0F,#2C,#40,#A5,#0F,#3F,#3F,#2C,#40,#A5,#1F,#FF,#FF,#FE,#00,#B5,#FF,#FF,#FF,#FE,#40,#B4,#FF,#FF,#FF,#FE,#00
            db #97,#80,#00,#00,#20,#00,#97,#E8,#00,#00,#40,#70,#97,#FC,#F0,#F0,#C0,#F6,#87,#FC,#F0,#F0,#B0,#DE,#87,#FE,#F0,#F0,#F1,#DE,#87,#7F,#F0,#F0,#F3,#9E,#87,#3F,#00,#00,#33,#1E,#87,#3F,#88,#00,#77,#1E
            db #87,#1F,#FF,#FF,#EF,#1E,#87,#0F,#FF,#FF,#CF,#1E,#83,#0F,#7F,#FF,#8F,#1E,#80,#0F,#3F,#FF,#0F,#1C,#80,#03,#0F,#0F,#0F,#10,#80,#00,#0F,#0F,#0C,#10,#80,#00,#07,#0F,#08,#10,#F0,#F0,#F0,#F0,#F0,#F0


;### PRGPRZ -> Programm-Prozess
dskprzn     db 2
sysprzn     db 3
windatprz   equ 3   ;Prozenummer
windatsup   equ 51  ;Nummer des Superfensters+1 oder 0
prgwin      db 0    ;Nummer des Haupt-Fensters

prgprz  ld a,(prgprzn)
        ld (prgwindat+windatprz),a

        call spkrel

        ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,prgwindat
        call msgsnd             ;Fenster aufbauen
prgprz1 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        jp z,prgend             ;kein Speicher fr Fenster -> Proze beenden
        cp MSR_DSK_WOPNOK
        jr nz,prgprz1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (prgwin),a           ;Fenster wurde geffnet -> Nummer merken

prgprz0 call msgget
        jr nc,prgprz0
        cp MSR_DSK_WCLICK       ;*** Fenster-Aktion wurde geklickt
        jr nz,prgprz0
prgprz3 ld a,(iy+2)             ;*** HAUPT-FENSTER
        cp DSK_ACT_CLOSE        ;*** Close wurde geklickt
        jp z,prgend
        cp DSK_ACT_CONTENT      ;*** Inhalt wurde geklickt
        jr nz,prgprz0
        ld l,(iy+8)
        ld h,(iy+9)
        ld a,l
        or h
        jr z,prgprz0
        jp (hl)

;### PRGEND -> Programm beenden
prgend  ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        ld (iy+0),MSC_SYS_PRGEND
        ld a,(prgcodbeg+prgpstnum)
        ld (iy+1),a
        rst #10
prgend0 rst #30
        jr prgend0

;### PRGINF -> Info-Fenster anzeigen
prginf  ld hl,prgmsginf         ;*** Info-Fenster
        ld b,1+128
prginf0 call prginf1
        jp prgprz0
prginf1 ld (prgmsgb+1),hl
        ld a,(prgbnknum)
        ld c,a
        ld (prgmsgb+3),bc
        ld a,MSC_SYS_SYSWRN
        ld (prgmsgb),a
prginf2 ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        rst #10
        ret


;==============================================================================
;### SUB-ROUTINEN #############################################################
;==============================================================================

;### MSGGET -> Message fr Programm abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgget  ld a,(prgprzn)
        db #dd:ld l,a           ;IXL=Rechner-Proze-Nummer
        db #dd:ld h,-1
        ld iy,prgmsgb           ;IY=Messagebuffer
        rst #08                 ;Message holen -> IXL=Status, IXH=Absender-Proze
        or a
        db #dd:dec l
        ret nz
        ld iy,prgmsgb
        ld a,(iy+0)
        or a
        jp z,prgend
        scf
        ret

;### MSGDSK -> Message fr Programm von Desktop-Prozess abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgdsk  call msgget
        jr nc,msgdsk            ;keine Message
        ld a,(dskprzn)
        db #dd:cp h
        jr nz,msgdsk            ;Message von anderem als Desktop-Proze -> ignorieren
        ld a,(prgmsgb)
        ret

;### MSGSND -> Message an Desktop-Prozess senden
;### Eingabe    C=Kommando, B/E/D/L/H=Parameter1/2/3/4/5
msgsnd0 ld a,(prgwin)
        ld b,a
        ld c,MSC_DSK_WININH
msgsnd  ld a,(dskprzn)
msgsnd1 db #dd:ld h,a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),b
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        rst #10
        ret

;### CLCDEZ -> Rechnet Byte in zwei Dezimalziffern um
;### Eingabe    A=Wert
;### Ausgabe    L=10er-Ascii-Ziffer, H=1er-Ascii-Ziffer
;### Veraendert AF
clcdez  ld l,0
clcdez1 sub 10
        jr c,clcdez2
        inc l
        jr clcdez1
clcdez2 add "0"+10
        ld h,a
        ld a,"0"
        add l
        ld l,a
        ret

;### STRLEN -> Ermittelt Lnge eines Strings
;### Eingabe    HL=String
;### Ausgabe    HL=Stringende (0), BC=Lnge (maximal 255)
;### Verndert  -
strlen  push af
        xor a
        ld bc,255
        cpir
        ld a,254
        sub c
        ld c,a
        dec hl
        pop af
        ret

;### STRINP -> Initialisiert Input-Control
;### Eingabe    IX=Control
;### Ausgabe    BC=String-Lnge (maximal 255)
;### Verndert  HL,BC
strinp  ld l,(ix+0)
        ld h,(ix+1)
        call strlen
        ld (ix+2),0
        ld (ix+3),0
        ld (ix+4),c
        ld (ix+5),b
        ld (ix+6),0
        ld (ix+7),0
        ld (ix+8),c
        ld (ix+9),b
        ret


;==============================================================================
;### STEUER-ROUTINEN ##########################################################
;==============================================================================

ctlsay  ld hl,prgobjinpb
        call spksay
        jp prgprz0

ctlspk  ld hl,prgobjinpb
        call spkspk
        jp prgprz0

ctlchn  ld a,(prgobjradv)
        call spkchn
        jp prgprz0

ctlptc  ld a,(prgobjsld1+2)
        inc a
        push af
        call clcdez
        ld (prgobjtxta),hl
        ld e,4
        call msgsnd0
        pop af
        call spkptc
        jp prgprz0


;==============================================================================
;### SPEECH-ROUTINEN ##########################################################
;==============================================================================

spkcodini   equ 4493    ;Offset RSX-Init-Routine
spkcodptc   equ 3*0+17+spkcodini+spkdatcod
spkcodsay   equ 3*1+17+spkcodini+spkdatcod
spkcodspk   equ 3*2+17+spkcodini+spkdatcod
spkcodlft   equ 3*3+17+spkcodini+spkdatcod
spkcodrig   equ 3*4+17+spkcodini+spkdatcod
spkcodcen   equ 3*5+17+spkcodini+spkdatcod

spkcodlen   equ 5442    ;Lnge Code
spkptblen   equ 2723    ;Lnge Pronounce-Table

;### SPKREL -> Relociert und initialisiert Speech-Code
spkrel  ld ix,spkdatrel             ;Code relocieren
        ld bc,spkdatcod
spkrel1 ld l,(ix+0)
        ld h,(ix+1)
        ld a,l
        or h
        jr z,spkrel2
        add hl,bc
        ld a,(hl):add c:ld (hl),a
        inc hl
        ld a,(hl):adc b:ld (hl),a
        inc ix
        inc ix
        jr spkrel1
spkrel2 ld de,spkdatcod+spkcodlen   ;Pronounce-Table relocieren
        push de
        pop ix
        ld b,28
spkrel3 ld l,(ix+0)
        ld h,(ix+1)
        add hl,de
        ld (ix+0),l
        ld (ix+1),h
        inc ix
        inc ix
        djnz spkrel3
        ret

;### SPKPTC -> Setzt den Pitch
;### Eingabe    A=Pitch (1-20)
spkptcb dw 0
spkptc  ld ix,spkptcb
        ld (ix+0),a
        ld (ix+1),0
        ld a,1
        jp spkcodptc

;### SPKCHN -> Setzt den Kanal
;### Eingabe    A=Kanal (0=Links, 1=Center, 2=Rechts)
spkchn  cp 1
        ld a,0
        jp c,spkcodlft
        jp z,spkcodcen
        jp spkcodrig

;### SPKSAY -> Spricht Text
;### Eingabe    HL=Text
spksayb dw spksayb+2
        ds 3
spksay  call spksay1
        jp spkcodsay
spksay1 ld ix,spksayb
        ld (spksayb+3),hl
        call strlen
        ld (ix+2),c
        ld a,1
        ret

;### SPKSPK -> Pronounct Text
;### Eingabe    HL=Text
spkspk  call spksay1
        jp spkcodspk


spkdatcod   ;Speech-Code (c) 1986 by Amsoft
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#CD,#1C,#03,#F3,#21,#00,#00,#22,#21,#01,#2A,#21,#01,#22,#26,#01,#7E,#FE,#0D,#28,#05,#CD,#2C,#03,#18,#F0,#FB,#C9,#10,#10,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#09,#06,#F4,#ED,#79,#06,#F6,#3E,#80,#ED,#79,#AF,#ED,#79
db #C9,#06,#F6,#3E,#C0,#ED,#79,#06,#F4,#ED,#59,#06,#F6,#AF,#ED,#79,#C9,#21,#4D,#11,#CD,#E3,#01,#C9,#3E,#03,#CD,#4C,#01,#C9,#CD,#CE,#07,#7E,#FE,#31,#D8,#FE,#39,#D0,#D6,#30,#E5,#67,#3A,#1C,#01,#84,#D6,#04,#32,#1C,#01,#E1,#23,#22,#21,#01,#C9,#32,#20,#01,#22
db #1E,#01,#1E,#01,#CD,#3C,#01,#AF,#CD,#2E,#01,#1E,#00,#CD,#3C,#01,#AF,#CD,#2E,#01,#1E,#07,#CD,#3C,#01,#3E,#3E,#CD,#2E,#01,#3A,#2D,#01,#5F,#CD,#3C,#01,#3A,#20,#01,#87,#87,#87,#57,#CD,#01,#03,#E6,#3F,#4F,#2A,#1E,#01,#AF,#06,#00,#ED,#4A,#1E,#08,#7E,#00,#00
db #00,#E6,#0F,#CD,#2E,#01,#3A,#1C,#01,#47,#10,#FE,#7E,#CB,#2F,#CB,#2F,#CB,#2F,#CB,#2F,#E6,#0F,#CD,#2E,#01,#3A,#1C,#01,#47,#10,#FE,#23,#1D,#C2,#B6,#01,#15,#C2,#A6,#01,#C9,#32,#20,#01,#22,#1E,#01,#1E,#01,#CD,#3C,#01,#AF,#CD,#2E,#01,#1E,#00,#CD,#3C,#01,#AF
db #CD,#2E,#01,#1E,#07,#CD,#3C,#01,#3E,#3E,#CD,#2E,#01,#3A,#2D,#01,#5F,#CD,#3C,#01,#3A,#20,#01,#57,#2A,#1E,#01,#1E,#3F,#7E,#E6,#0F,#CD,#2E,#01,#3A,#1C,#01,#47,#10,#FE,#7E,#CB,#2F,#CB,#2F,#CB,#2F,#CB,#2F,#E6,#0F,#CD,#2E,#01,#3A,#1C,#01,#47,#10,#FE,#00,#00
db #00,#23,#1D,#C2,#15,#02,#15,#C2,#10,#02,#C9,#74,#FF,#FF,#04,#30,#FB,#CF,#88,#88,#78,#45,#95,#CD,#6A,#44,#85,#AA,#68,#65,#76,#88,#88,#88,#68,#55,#86,#A9,#8A,#56,#65,#87,#A8,#CB,#8A,#56,#85,#BA,#8A,#78,#87,#88,#88,#66,#55,#76,#88,#56,#54,#65,#65,#56,#55
db #44,#54,#66,#56,#55,#65,#56,#54,#86,#46,#44,#99,#58,#65,#88,#48,#A3,#AB,#76,#C9,#4A,#21,#84,#69,#44,#C7,#4A,#52,#A9,#48,#72,#ED,#8B,#78,#55,#24,#32,#F4,#CF,#10,#FB,#4F,#54,#98,#68,#74,#88,#56,#85,#89,#56,#87,#78,#76,#98,#99,#99,#89,#68,#76,#67,#65,#98
db #78,#44,#54,#B8,#AB,#69,#55,#76,#88,#56,#65,#98,#96,#78,#78,#B9,#B8,#78,#89,#76,#65,#78,#4B,#87,#75,#8B,#B5,#76,#A8,#A9,#44,#5D,#49,#8B,#83,#95,#78,#1A,#6C,#7A,#C2,#B4,#55,#7B,#85,#A8,#78,#98,#85,#87,#C4,#85,#85,#3B,#B8,#47,#78,#A4,#94,#68,#87,#66,#7A
db #7A,#89,#67,#C8,#A6,#83,#7B,#C5,#C1,#B4,#98,#87,#B3,#3A,#23,#01,#EE,#65,#CE,#25,#32,#23,#01,#21,#23,#01,#CB,#16,#23,#CB,#16,#23,#CB,#16,#3A,#23,#01,#E6,#0F,#C9,#3E,#65,#32,#23,#01,#3E,#25,#32,#24,#01,#3E,#63,#32,#25,#01,#C9,#3A,#1D,#01,#32,#1C,#01,#2A
db #21,#01,#7E,#FE,#41,#CA,#C6,#03,#FE,#55,#CA,#17,#05,#FE,#49,#CA,#7E,#04,#FE,#45,#CA,#48,#04,#FE,#4F,#CA,#BC,#04,#FE,#53,#CA,#B5,#06,#FE,#2F,#CA,#62,#05,#FE,#44,#CA,#7E,#05,#FE,#43,#CA,#F1,#05,#FE,#54,#CA,#3E,#06,#FE,#4E,#CA,#DC,#06,#FE,#5A,#CA,#86,#06
db #FE,#42,#CA,#05,#07,#FE,#46,#CA,#AE,#07,#FE,#47,#CA,#BB,#07,#FE,#4A,#CA,#89,#07,#FE,#4B,#CA,#54,#07,#FE,#4C,#CA,#25,#07,#FE,#4D,#CA,#32,#07,#FE,#50,#CA,#67,#07,#FE,#52,#CA,#18,#07,#FE,#56,#CA,#3F,#07,#FE,#57,#CA,#7C,#07,#FE,#59,#CA,#A1,#07,#FE,#25,#28
db #0A,#23,#22,#21,#01,#3E,#04,#CD,#4C,#01,#C9,#23,#22,#21,#01,#3E,#02,#CD,#4C,#01,#C9,#23,#46,#23,#22,#21,#01,#CD,#59,#01,#78,#FE,#59,#28,#38,#FE,#45,#28,#5E,#FE,#41,#28,#63,#FE,#57,#28,#45,#FE,#48,#28,#1F,#FE,#4F,#28,#12,#FE,#49,#28,#05,#2B,#22,#21,#01
db #C9,#21,#6D,#08,#3E,#09,#CD,#E3,#01,#C9,#21,#2D,#09,#3E,#09,#CD,#E3,#01,#C9,#21,#6C,#0A,#3E,#07,#CD,#E3,#01,#C9,#21,#FB,#0B,#3E,#09,#CD,#E3,#01,#21,#7C,#0C,#3E,#05,#CD,#E3,#01,#21,#3D,#0C,#3E,#02,#CD,#E3,#01,#C9,#21,#42,#02,#3E,#09,#CD,#E3,#01,#21,#BC
db #0B,#3E,#06,#CD,#E3,#01,#C9,#21,#42,#02,#3E,#07,#CD,#E3,#01,#C9,#21,#2D,#08,#3E,#09,#CD,#E3,#01,#C9,#23,#46,#23,#22,#21,#01,#CD,#59,#01,#78,#FE,#45,#28,#16,#FE,#48,#28,#1B,#FE,#52,#28,#05,#2B,#22,#21,#01,#C9,#21,#FA,#0D,#3E,#09,#CD,#E3,#01,#C9,#21,#6D
db #09,#3E,#07,#CD,#E3,#01,#C9,#21,#CD,#10,#3E,#07,#CD,#E3,#01,#C9,#23,#46,#23,#22,#21,#01,#CD,#59,#01,#78,#FE,#59,#28,#16,#FE,#58,#28,#23,#FE,#48,#28,#05,#2B,#22,#21,#01,#C9,#21,#7C,#0C,#3E,#07,#CD,#E3,#01,#C9,#21,#2D,#08,#3E,#09,#CD,#E3,#01,#21,#7C,#0C
db #3E,#06,#CD,#E3,#01,#C9,#21,#7C,#0C,#3E,#05,#CD,#E3,#01,#C9,#23,#46,#23,#22,#21,#01,#CD,#59,#01,#78,#FE,#57,#28,#1A,#FE,#59,#28,#27,#FE,#48,#28,#3C,#FE,#4F,#28,#05,#2B,#22,#21,#01,#C9,#21,#BA,#0D,#3E,#08,#CD,#E3,#01,#C9,#21,#7B,#0D,#3E,#09,#CD,#E3,#01
db #21,#BC,#0B,#3E,#05,#CD,#E3,#01,#C9,#21,#2D,#09,#3E,#09,#CD,#E3,#01,#21,#7C,#0C,#3E,#04,#CD,#E3,#01,#21,#3D,#0C,#3E,#02,#CD,#E3,#01,#C9,#21,#7B,#0D,#3E,#08,#CD,#E3,#01,#C9,#23,#46,#23,#22,#21,#01,#CD,#59,#01,#78,#FE,#58,#28,#34,#FE,#57,#28,#1F,#FE,#48
db #28,#12,#FE,#55,#28,#05,#2B,#22,#21,#01,#C9,#21,#4B,#10,#3E,#08,#CD,#E3,#01,#C9,#21,#0D,#11,#3E,#07,#CD,#E3,#01,#C9,#21,#ED,#08,#3E,#07,#CD,#E3,#01,#21,#BC,#0B,#3E,#06,#CD,#E3,#01,#C9,#21,#ED,#08,#3E,#08,#CD,#E3,#01,#C9,#23,#46,#23,#22,#21,#01,#CD,#59
db #01,#78,#FE,#48,#28,#05,#2B,#22,#21,#01,#C9,#21,#3C,#0B,#3E,#04,#CD,#76,#01,#C9,#23,#7E,#FE,#48,#CA,#A1,#05,#FE,#52,#CA,#B6,#05,#FE,#55,#CA,#D3,#05,#22,#21,#01,#CD,#53,#01,#21,#FA,#0C,#3E,#01,#CD,#E3,#01,#CD,#53,#01,#C9,#23,#22,#21,#01,#21,#0A,#10,#3E
db #04,#CD,#E3,#01,#21,#3C,#0B,#3E,#01,#CD,#76,#01,#C9,#23,#22,#21,#01,#21,#8A,#0F,#3E,#02,#CD,#E3,#01,#21,#BA,#0C,#3E,#03,#CD,#E3,#01,#21,#AD,#08,#3E,#07,#CD,#E3,#01,#C9,#23,#23,#22,#21,#01,#21,#8A,#0F,#3E,#05,#CD,#E3,#01,#21,#BA,#0C,#3E,#02,#CD,#E3,#01
db #21,#ED,#08,#3E,#08,#CD,#E3,#01,#C9,#23,#7E,#23,#22,#21,#01,#FE,#48,#28,#2A,#FE,#54,#28,#05,#2B,#22,#21,#01,#C9,#21,#8A,#0F,#3E,#02,#CD,#E3,#01,#21,#81,#02,#3E,#01,#CD,#E3,#01,#21,#8A,#0F,#3E,#01,#CD,#E3,#01,#21,#C1,#02,#3E,#01,#CD,#E3,#01,#C9,#21,#8A
db #0F,#3E,#06,#CD,#E3,#01,#21,#3A,#0E,#3E,#03,#CD,#E3,#01,#21,#42,#02,#3E,#01,#CD,#E3,#01,#C9,#23,#7E,#FE,#48,#28,#18,#FE,#52,#28,#21,#22,#21,#01,#3E,#03,#CD,#4C,#01,#21,#C1,#02,#3E,#01,#CD,#E3,#01,#CD,#53,#01,#C9,#23,#22,#21,#01,#21,#CA,#0F,#3E,#05,#CD
db #76,#01,#C9,#23,#22,#21,#01,#21,#8A,#0F,#3E,#04,#CD,#E3,#01,#21,#3A,#0E,#3E,#03,#CD,#E3,#01,#21,#AD,#08,#3E,#07,#CD,#E3,#01,#C9,#23,#7E,#FE,#48,#28,#14,#22,#21,#01,#21,#2C,#0A,#3E,#05,#CD,#E3,#01,#21,#BA,#0E,#3E,#05,#CD,#76,#01,#C9,#23,#22,#21,#01,#21
db #3D,#0C,#3E,#03,#CD,#E3,#01,#21,#3A,#0E,#3E,#03,#CD,#76,#01,#C9,#23,#7E,#FE,#48,#28,#14,#22,#21,#01,#3A,#1C,#01,#D6,#02,#32,#1C,#01,#21,#BA,#0E,#3E,#05,#CD,#76,#01,#C9,#23,#22,#21,#01,#21,#3A,#0E,#3E,#06,#CD,#76,#01,#C9,#23,#7E,#FE,#58,#28,#16,#22,#21
db #01,#3E,#01,#CD,#4C,#01,#21,#ED,#09,#3E,#07,#CD,#E3,#01,#3E,#01,#CD,#4C,#01,#C9,#23,#22,#21,#01,#21,#3A,#0D,#3E,#07,#CD,#E3,#01,#C9,#23,#22,#21,#01,#CD,#53,#01,#21,#FC,#0A,#3E,#01,#CD,#E3,#01,#CD,#53,#01,#C9,#23,#22,#21,#01,#21,#AD,#08,#3E,#07,#CD,#E3
db #01,#C9,#23,#22,#21,#01,#21,#AD,#09,#3E,#07,#CD,#E3,#01,#C9,#23,#22,#21,#01,#21,#2C,#0A,#3E,#07,#CD,#E3,#01,#C9,#23,#22,#21,#01,#21,#AC,#0A,#3E,#05,#CD,#E3,#01,#21,#3C,#0B,#3E,#01,#CD,#76,#01,#C9,#23,#22,#21,#01,#CD,#53,#01,#21,#81,#02,#3E,#01,#CD,#E3
db #01,#CD,#53,#01,#C9,#23,#22,#21,#01,#CD,#53,#01,#21,#7C,#0B,#3E,#01,#CD,#E3,#01,#3E,#03,#CD,#53,#01,#C9,#23,#22,#21,#01,#21,#BC,#0B,#3E,#07,#CD,#E3,#01,#C9,#23,#22,#21,#01,#CD,#53,#01,#21,#FA,#0C,#3E,#01,#CD,#E3,#01,#21,#3A,#0E,#3E,#04,#CD,#76,#01,#C9
db #23,#22,#21,#01,#21,#3D,#0C,#3E,#07,#CD,#E3,#01,#C9,#23,#22,#21,#01,#21,#02,#0F,#3E,#05,#CD,#76,#01,#C9,#23,#22,#21,#01,#CD,#53,#01,#21,#7A,#0E,#3E,#01,#CD,#E3,#01,#CD,#53,#01,#C9,#F5,#E5,#D5,#ED,#5B,#26,#01,#2A,#28,#01,#AF,#ED,#52,#7C,#B5,#28,#0E,#2A
db #2A,#01,#AF,#ED,#52,#7C,#B5,#28,#23,#D1,#E1,#F1,#C9,#3A,#2C,#01,#FE,#3F,#28,#06,#FE,#2E,#28,#0B,#18,#EF,#3A,#1C,#01,#3D,#32,#1C,#01,#18,#E6,#3A,#1C,#01,#3C,#32,#1C,#01,#18,#DD,#3A,#2C,#01,#FE,#3F,#28,#06,#FE,#2E,#28,#0C,#18,#D0,#3A,#1C,#01,#3D,#3D,#32
db #1C,#01,#18,#C6,#3A,#1C,#01,#3C,#3C,#32,#1C,#01,#18,#BC,#96,#EE,#FF,#ED,#44,#10,#52,#D9,#EF,#BD,#58,#45,#66,#86,#88,#77,#A8,#BA,#9B,#48,#44,#53,#A7,#CB,#AB,#68,#55,#65,#87,#99,#89,#88,#88,#A9,#99,#88,#78,#98,#A9,#99,#78,#66,#87,#98,#88,#68,#66,#76,#88
db #88,#78,#67,#66,#66,#66,#66,#66,#76,#77,#66,#67,#67,#87,#77,#66,#96,#B8,#FF,#CB,#FB,#9A,#85,#73,#78,#58,#BA,#9D,#99,#89,#88,#44,#64,#58,#86,#A9,#AA,#88,#86,#58,#54,#76,#87,#88,#99,#9A,#78,#88,#67,#66,#86,#88,#9A,#CA,#AA,#A8,#88,#86,#76,#88,#89,#88,#89
db #67,#66,#65,#65,#65,#66,#66,#66,#56,#55,#55,#55,#44,#77,#68,#2B,#44,#75,#EA,#FF,#AC,#DA,#EE,#5A,#32,#65,#56,#55,#76,#BA,#CD,#8B,#87,#99,#48,#22,#53,#77,#66,#97,#AA,#AB,#8A,#66,#76,#57,#44,#75,#98,#88,#98,#AA,#BB,#AB,#89,#87,#88,#56,#75,#88,#88,#88,#88
db #68,#56,#55,#55,#55,#55,#55,#66,#56,#66,#56,#55,#55,#44,#65,#66,#55,#44,#54,#55,#55,#76,#B9,#FD,#FF,#FF,#EE,#DE,#CD,#AB,#68,#45,#23,#32,#44,#44,#55,#76,#A9,#BA,#BB,#AB,#AA,#9A,#89,#68,#55,#44,#44,#54,#65,#66,#87,#98,#A9,#AA,#AA,#9A,#A9,#AA,#AA,#9A,#89
db #88,#88,#88,#88,#66,#55,#55,#55,#55,#45,#44,#54,#55,#55,#45,#44,#44,#54,#55,#65,#66,#67,#87,#B9,#EC,#FF,#FF,#CF,#8A,#24,#01,#31,#75,#DA,#FE,#FF,#CE,#8A,#56,#44,#54,#65,#88,#99,#AA,#AA,#BB,#BB,#AA,#89,#57,#45,#54,#75,#A8,#CB,#DD,#DD,#BC,#9A,#68,#56,#55
db #65,#87,#A9,#BB,#BB,#9A,#88,#66,#55,#55,#66,#87,#98,#99,#99,#88,#67,#56,#55,#35,#43,#07,#E1,#A4,#79,#BD,#E8,#FD,#DA,#CF,#DB,#FB,#9A,#AB,#68,#96,#45,#54,#25,#52,#44,#54,#56,#65,#87,#76,#9A,#98,#AA,#99,#AA,#89,#A9,#89,#88,#68,#86,#68,#65,#67,#85,#77,#79
db #A9,#87,#AA,#AA,#9A,#A9,#98,#88,#88,#67,#66,#55,#55,#55,#54,#55,#44,#45,#54,#34,#55,#55,#75,#A8,#DB,#FE,#EF,#BE,#8B,#68,#55,#54,#54,#55,#55,#66,#87,#99,#AA,#AB,#AA,#89,#66,#55,#55,#55,#65,#76,#87,#88,#99,#99,#99,#9A,#99,#99,#98,#88,#88,#68,#67,#67,#77
db #76,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#66,#55,#55,#66,#66,#76,#9A,#A6,#BB,#CB,#BB,#DE,#ED,#DD,#DD,#BC,#BC,#BA,#9A,#99,#78,#68,#66,#56,#55,#55,#55,#55,#55,#66,#65,#66,#76,#77,#88,#88,#88,#98,#99,#AA,#AA,#AA,#BA,#BA
db #AB,#AA,#AA,#99,#89,#88,#68,#66,#55,#55,#44,#44,#44,#44,#44,#44,#44,#54,#45,#55,#65,#32,#43,#34,#43,#44,#55,#55,#65,#76,#B9,#A8,#9A,#BB,#CD,#DD,#DD,#EE,#ED,#DD,#DC,#BB,#AB,#99,#89,#88,#66,#56,#55,#45,#44,#54,#55,#55,#55,#65,#66,#87,#88,#88,#99,#99,#AA
db #AA,#BA,#AB,#BB,#AB,#BB,#BB,#AA,#9A,#89,#88,#78,#66,#56,#55,#44,#44,#34,#33,#33,#34,#43,#55,#D7,#FF,#BF,#49,#33,#67,#68,#89,#A9,#DD,#8B,#24,#22,#95,#AA,#9A,#89,#99,#58,#34,#54,#A7,#BB,#8A,#68,#66,#66,#65,#97,#BA,#AB,#68,#55,#76,#98,#89,#98,#88,#68,#56
db #75,#88,#89,#68,#66,#66,#66,#66,#76,#88,#67,#56,#55,#76,#67,#76,#66,#77,#66,#66,#56,#66,#67,#99,#99,#99,#78,#77,#77,#67,#66,#77,#77,#77,#98,#99,#99,#A9,#AA,#99,#99,#99,#78,#77,#77,#67,#66,#77,#77,#77,#98,#99,#99,#A9,#AA,#89,#99,#99,#99,#AA,#9A,#99,#99
db #89,#77,#77,#77,#66,#76,#77,#77,#87,#99,#99,#99,#AA,#9A,#99,#99,#89,#77,#77,#77,#66,#76,#77,#77,#87,#99,#99,#99,#AA,#9A,#99,#99,#89,#77,#77,#77,#66,#76,#77,#77,#86,#88,#98,#88,#88,#88,#99,#89,#88,#88,#88,#88,#99,#88,#88,#98,#99,#88,#88,#88,#88,#88,#88
db #88,#88,#88,#88,#78,#88,#87,#77,#77,#88,#88,#77,#87,#88,#88,#77,#66,#66,#66,#56,#55,#55,#55,#66,#B8,#FE,#FF,#CE,#9A,#89,#48,#24,#01,#20,#55,#66,#56,#55,#55,#24,#00,#88,#88,#68,#86,#78,#97,#89,#88,#76,#76,#88,#89,#99,#88,#68,#56,#87,#99,#A9,#89,#66,#56
db #76,#88,#88,#89,#78,#77,#88,#88,#99,#88,#68,#55,#75,#A9,#9A,#89,#68,#55,#66,#86,#A9,#9A,#88,#56,#86,#88,#88,#68,#75,#77,#98,#AA,#98,#89,#58,#55,#66,#B9,#AB,#8A,#58,#65,#88,#99,#99,#A9,#DA,#BC,#ED,#CD,#BB,#CC,#DC,#FD,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF
db #FF,#FF,#FF,#FF,#FF,#8C,#04,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#10,#32,#45,#13,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#10,#11,#10,#11,#11,#32,#54,#55,#76,#76,#44,#55,#76,#B9,#DC,#FE,#FF,#DE,#CD,#AB,#9A,#88,#56,#45,#23,#22,#43,#54,#86,#98
db #A9,#AA,#9A,#99,#99,#89,#88,#56,#45,#44,#54,#55,#66,#76,#87,#88,#98,#99,#99,#A9,#AA,#AA,#AA,#9A,#89,#78,#66,#66,#66,#66,#56,#55,#55,#55,#66,#66,#66,#56,#55,#55,#55,#55,#55,#45,#B6,#FF,#A5,#FB,#6A,#84,#95,#56,#73,#D9,#69,#B8,#8C,#56,#66,#67,#44,#A6,#8A
db #96,#AA,#68,#65,#76,#46,#75,#99,#88,#A9,#8A,#67,#76,#67,#65,#97,#88,#D2,#9A,#A9,#A9,#59,#65,#89,#55,#98,#88,#67,#66,#46,#54,#66,#55,#66,#55,#86,#56,#76,#56,#55,#56,#65,#45,#87,#58,#75,#55,#95,#54,#5C,#87,#A9,#A8,#AD,#BB,#BD,#9D,#9F,#AB,#AB,#8A,#8B,#88
db #88,#46,#47,#44,#55,#44,#55,#40,#65,#55,#87,#86,#97,#88,#99,#98,#A9,#99,#9A,#98,#99,#98,#9A,#99,#99,#98,#8A,#88,#88,#78,#68,#66,#56,#55,#45,#54,#44,#54,#44,#55,#54,#55,#44,#64,#54,#47,#A4,#58,#D5,#1F,#D7,#8F,#A5,#88,#84,#34,#8B,#34,#B6,#5A,#B7,#6C,#89
db #89,#87,#55,#67,#44,#87,#58,#99,#89,#99,#99,#88,#86,#88,#65,#88,#98,#89,#AB,#9B,#B9,#89,#86,#58,#65,#55,#54,#55,#67,#66,#88,#66,#87,#55,#56,#64,#46,#75,#46,#84,#59,#75,#89,#74,#67,#76,#66,#67,#66,#77,#87,#77,#89,#88,#89,#89,#89,#A8,#99,#9A,#A9,#9A,#BA
db #9A,#9A,#A9,#89,#89,#88,#79,#87,#77,#67,#66,#67,#76,#76,#67,#77,#77,#88,#97,#89,#99,#99,#AA,#A9,#9A,#AA,#A9,#9A,#99,#89,#99,#87,#78,#77,#67,#77,#12,#66,#67,#66,#77,#87,#77,#89,#88,#89,#3A,#FB,#98,#6C,#A9,#A5,#5A,#89,#A8,#58,#67,#67,#55,#55,#66,#56,#76
db #88,#76,#86,#87,#54,#55,#47,#55,#85,#65,#66,#88,#8A,#A8,#AA,#89,#98,#89,#67,#88,#89,#98,#BA,#AB,#BA,#BC,#AB,#AA,#AA,#78,#87,#78,#66,#86,#88,#87,#98,#88,#77,#78,#56,#55,#56,#44,#54,#45,#44,#44,#A6,#AA,#BB,#CB,#BD,#BD,#AB,#AA,#BA,#9A,#89,#88,#88,#88,#66
db #66,#66,#66,#67,#87,#78,#88,#88,#88,#66,#87,#77,#77,#77,#77,#88,#88,#88,#99,#AA,#AA,#AA,#AA,#99,#99,#99,#88,#88,#66,#66,#55,#55,#55,#55,#55,#55,#55,#55,#55,#55,#55,#55,#65,#56,#55,#55,#55,#55,#45,#66,#66,#F7,#FF,#9E,#5B,#74,#88,#56,#54,#75,#DB,#BD,#88
db #46,#B1,#58,#45,#65,#B7,#CB,#8A,#68,#56,#76,#56,#54,#87,#BA,#AB,#78,#77,#66,#66,#56,#96,#DA,#BD,#8B,#56,#75,#67,#76,#98,#9A,#88,#66,#65,#77,#66,#56,#66,#87,#66,#55,#65,#66,#56,#65,#66,#77,#88,#67,#95,#DB,#FF,#FF,#4A,#02,#00,#73,#FB,#FF,#AF,#48,#23,#42
db #75,#88,#99,#98,#AA,#AA,#68,#25,#22,#53,#B8,#ED,#BD,#69,#24,#32,#75,#A9,#AB,#9A,#88,#88,#A9,#89,#67,#66,#87,#89,#89,#69,#67,#66,#66,#66,#55,#66,#86,#78,#66,#55,#55,#55,#66,#66,#66,#66,#66,#66,#56,#45,#67,#D7,#FF,#AB,#CB,#AC,#89,#26,#52,#87,#56,#86,#BA
db #CB,#8B,#76,#88,#48,#44,#55,#76,#89,#88,#B9,#AB,#88,#67,#66,#66,#45,#75,#98,#99,#99,#99,#BA,#8A,#87,#88,#78,#77,#76,#98,#89,#87,#88,#78,#66,#55,#65,#66,#65,#66,#66,#66,#56,#65,#56,#55,#65,#56,#66,#66,#66,#8B,#43,#97,#3B,#93,#4C,#55,#3F,#74,#59,#58,#C8
db #03,#C7,#26,#C3,#18,#77,#7A,#34,#C9,#82,#A1,#2B,#81,#2D,#76,#A8,#38,#78,#7A,#E0,#48,#A6,#83,#47,#3B,#A5,#3A,#85,#3B,#98,#64,#89,#56,#B8,#88,#83,#67,#87,#27,#77,#0D,#73,#5E,#72,#CC,#70,#D8,#44,#47,#59,#98,#58,#76,#87,#88,#98,#99,#AA,#AA,#AA,#AA,#99,#89
db #88,#88,#77,#66,#66,#55,#45,#41,#B7,#DC,#BE,#99,#B9,#BB,#8A,#45,#43,#54,#55,#24,#42,#65,#76,#56,#54,#65,#77,#66,#86,#CB,#ED,#CE,#BB,#BA,#AB,#99,#68,#65,#66,#76,#86,#77,#87,#88,#89,#88,#78,#99,#99,#99,#98,#99,#9A,#B6,#75,#5A,#4B,#99,#B5,#58,#5B,#89,#A6
db #96,#68,#88,#A6,#78,#4A,#8B,#A5,#A5,#4A,#4B,#B7,#B4,#7A,#4C,#87,#C3,#78,#2C,#4B,#C5,#A4,#3A,#5B,#99,#95,#88,#49,#B7,#B4,#68,#8A,#A7,#B5,#78,#4C,#9A,#A5,#78,#5A,#87,#B5,#78,#5C,#6B,#A6,#78,#5A,#A7,#B3,#58,#2D,#89,#D5,#75,#5A,#4B,#A4,#3A,#78,#B5,#58,#65
db #66,#6A,#66,#A7,#98,#66,#6A,#66,#A7,#A6,#67,#66,#68,#A6,#6A,#67,#A7,#98,#66,#66,#A7,#9A,#A5,#86,#66,#77,#68,#A6,#9A,#59,#66,#89,#A7,#89,#65,#68,#86,#A6,#76,#68,#86,#66,#AA,#68,#6A,#76,#86,#76,#7A,#66,#A6,#6A,#7A,#66,#A6,#8A,#76,#7A,#8A,#95,#6A,#A6,#65
db #66,#6A,#66,#A7,#6A,#66,#89,#59,#00,#89,#89,#89,#A8,#99,#9A,#A9,#9A,#BA,#9A,#9A,#A9,#89,#88,#79,#87,#77,#67,#66,#67,#76,#76,#67,#77,#77,#88,#97,#89,#99,#99,#AA,#A9,#9A,#AA,#A9,#9A,#99,#89,#99,#87,#78,#77,#67,#77,#76,#66,#67,#66,#77,#87,#77,#89,#88,#89
db #89,#89,#A8,#99,#9A,#A9,#9A,#BA,#9A,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88
db #88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#87,#88,#79,#86,#88,#76,#86,#86,#66,#66,#76,#78,#98,#88,#8A,#99,#88,#89,#79,#7A,#8A,#99,#89,#A8,#98,#98,#68,#88,#89,#79,#78,#78,#88,#86,#88,#67,#68,#87,#87,#85,#67,#7A,#88,#8A,#8B,#9A,#A9,#99,#A9,#98,#A9
db #A9,#A8,#98,#A8,#96,#86,#76,#76,#78,#76,#66,#67,#98,#99,#A9,#AA,#9A,#AA,#89,#88,#78,#67,#76,#67,#76,#87,#88,#99,#9A,#A9,#AA,#99,#99,#89,#77,#77,#77,#66,#76,#77,#77,#88,#88,#A9,#AA,#A9,#AA,#89,#88,#78,#77,#77,#66,#76,#77,#87,#99,#99,#A9,#AA,#99,#9A,#89
db #88,#77,#66,#87,#99,#99,#AA,#AA,#A9,#9A,#88,#88,#77,#D6,#FC,#CD,#9C,#88,#88,#56,#44,#76,#BA,#AB,#99,#89,#78,#56,#44,#65,#98,#99,#99,#99,#89,#56,#45,#64,#87,#88,#98,#99,#99,#68,#55,#65,#86,#A9,#BB,#AB,#8A,#68,#56,#66,#87,#88,#88,#78,#56,#55,#55,#55,#65
db #66,#66,#56,#66,#55,#55,#56,#45,#65,#87,#88,#66,#55,#55,#98,#89,#AA,#99,#AA,#89,#89,#67,#77,#66,#77,#76,#88,#97,#A9,#A9,#AB,#99,#99,#87,#78,#76,#67,#76,#77,#97,#89,#A9,#9A,#B9,#99,#99,#78,#88,#66,#76,#66,#87,#88,#A9,#99,#AA,#99,#AA,#99,#9A,#88,#88,#76
db #67,#66,#77,#86,#88,#98,#98,#89,#AA,#99,#AA,#89,#89,#67,#77,#66,#77,#55,#87,#F4,#8F,#95,#8F,#23,#67,#86,#75,#FB,#79,#B8,#29,#53,#76,#66,#B8,#9C,#78,#88,#45,#65,#87,#97,#AA,#89,#87,#56,#55,#76,#88,#99,#8A,#68,#66,#55,#76,#AB,#98,#BA,#58,#65,#56,#76,#99
db #89,#88,#68,#55,#66,#66,#98,#88,#77,#66,#55,#56,#66,#66,#86,#57,#87,#56,#21,#32,#44,#44,#64,#86,#AA,#9A,#77,#B9,#FD,#FF,#CD,#BA,#CB,#CB,#8A,#55,#65,#A7,#AA,#89,#98,#B9,#CC,#AB,#68,#66,#88,#78,#57,#55,#97,#BA,#AB,#9A,#99,#AA,#9A,#68,#66,#86,#98,#99,#DB
db #FD,#FF,#DF,#AB,#89,#88,#68,#55,#55,#76,#88,#78,#56,#66,#66,#56,#34,#22,#32,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#9C,#11,#21,#97,#11,#CD,#D1,#BC,#C9,#00,#00,#00,#00,#00,#B3,#11,#C3,#F1,#11,#C3,#75,#12,#C3,#4C,#12,#C3,#D6,#11,#C3,#DF,#11,#C3,#E8,#11,#C3,#E8,#11,#50,#49,#54,#43,#C8
db #53,#41,#D9,#53,#50,#45,#41,#CB,#4C,#45,#46,#D4,#52,#49,#47,#48,#D4,#43,#45,#4E,#54,#45,#D2,#43,#45,#4E,#54,#52,#C5,#00,#B7,#20,#4E,#3E,#08,#32,#2D,#01,#C9,#B7,#20,#45,#3E,#0A,#32,#2D,#01,#C9,#B7,#20,#3C,#3E,#09,#32,#2D,#01,#C9,#FE,#01,#20,#32,#DD,#7E
db #01,#B7,#20,#2C,#DD,#7E,#00,#B7,#28,#26,#FE,#15,#30,#22,#2F,#C6,#1A,#32,#1D,#01,#C9,#53,#79,#6E,#74,#61,#78,#20,#65,#72,#72,#6F,#72,#2E,#4C,#69,#6E,#65,#20,#74,#6F,#6F,#20,#6C,#6F,#6E,#67,#2E,#21,#0C,#12,#18,#06,#E1,#E1,#E1,#21,#19,#12,#7E,#00,#00,#00
db #23,#7E,#FE,#2E,#20,#F7,#3E,#0D,#00,#00,#00,#3E,#0A,#00,#00,#00,#3E,#07,#00,#00,#00,#C9,#FE,#01,#20,#D7,#DD,#6E,#00,#DD,#66,#01,#7E,#B7,#C8,#23,#4E,#23,#46,#21,#00,#00,#57,#0A,#77,#23,#03,#15,#20,#F9,#3E,#0D,#77,#21,#00,#00,#CD,#24,#15,#CD,#00,#01,#C9
db #FE,#01,#20,#AE,#DD,#66,#01,#DD,#6E,#00,#7E,#B7,#C8,#23,#5E,#23,#56,#EB,#01,#E8,#13,#57,#3E,#20,#02,#03,#7E,#02,#23,#03,#15,#C2,#8F,#12,#3E,#20,#02,#03,#3E,#0D,#02,#CD,#21,#15,#CD,#D1,#13,#CD,#AD,#12,#C9,#00,#00,#00,#00,#00,#21,#E8,#13,#22,#A8,#12,#21
db #00,#00,#22,#2A,#01,#22,#28,#01,#21,#00,#00,#22,#21,#01,#16,#00,#CD,#D1,#12,#2A,#21,#01,#3E,#0D,#77,#CD,#00,#01,#C9,#CD,#8C,#13,#D8,#CD,#DE,#12,#CD,#98,#13,#C3,#D1,#12,#2A,#A8,#12,#7E,#FE,#41,#DA,#09,#13,#FE,#5B,#D2,#09,#13,#D6,#41,#87,#06,#00,#4F,#21
db #46,#15,#AF,#ED,#4A,#4E,#23,#46,#ED,#43,#AA,#12,#CD,#22,#13,#D8,#CD,#7D,#13,#C3,#FF,#12,#FE,#20,#CA,#18,#13,#01,#44,#15,#ED,#43,#AA,#12,#C3,#FF,#12,#01,#42,#15,#ED,#43,#AA,#12,#C3,#FF,#12,#2A,#A8,#12,#ED,#4B,#AA,#12,#0A,#FE,#20,#28,#43,#FE,#23,#28,#34
db #BE,#C2,#77,#13,#03,#23,#0A,#B7,#28,#0A,#7E,#FE,#0D,#CA,#77,#13,#0A,#C3,#2A,#13,#03,#2B,#ED,#43,#AA,#12,#22,#A8,#12,#7E,#CD,#BE,#13,#30,#0B,#0B,#0B,#0B,#0A,#03,#03,#03,#B7,#28,#01,#2B,#23,#22,#A8,#12,#37,#C9,#7E,#FE,#0D,#28,#0C,#32,#AC,#12,#C3,#36,#13
db #7E,#CD,#BE,#13,#38,#BF,#ED,#43,#AA,#12,#AF,#C9,#2A,#AA,#12,#01,#00,#00,#AF,#ED,#B1,#ED,#B1,#22,#AA,#12,#C9,#2A,#A8,#12,#7E,#FE,#0D,#28,#02,#AF,#C9,#37,#C9,#ED,#4B,#AA,#12,#2A,#21,#01,#0A,#14,#CA,#2C,#12,#B7,#28,#13,#FE,#23,#28,#09,#CD,#E8,#14,#77,#23
db #03,#C3,#9F,#13,#3A,#AC,#12,#C3,#AB,#13,#22,#21,#01,#C9,#FE,#30,#D8,#FE,#5B,#30,#0A,#FE,#41,#30,#04,#FE,#3A,#30,#02,#AF,#C9,#37,#C9,#21,#E8,#13,#7E,#FE,#20,#C2,#DE,#13,#23,#C3,#D4,#13,#FE,#0D,#C8,#32,#2C,#01,#23,#C3,#D4,#13,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00
db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#FE,#45,#28
db #17,#FE,#41,#28,#13,#FE,#4F,#28,#0F,#FE,#49,#28,#0B,#FE,#55,#28,#07,#F5,#AF,#32,#9B,#11,#F1,#C9,#F5,#3A,#9B,#11,#B7,#20,#11,#E5,#2A,#2A,#01,#22,#28,#01,#E1,#22,#2A,#01,#3C,#32,#9B,#11,#F1,#C9,#AF,#32,#9B,#11,#F1,#C9,#21,#E8,#13,#7E,#FE,#0D,#C8,#FE,#5C
db #28,#0F,#FE,#61,#38,#07,#FE,#7B,#30,#03,#D6,#20,#77,#23,#C3,#24,#15,#3E,#20,#77,#23,#C3,#24,#15,#31,#02,#35,#0A,#24,#05,#98,#06,#1D,#08,#A7,#09,#55,#07,#36,#07,#9C,#04,#62,#09,#9A,#01,#9A,#0A,#D4,#07,#CE,#09,#BC,#06,#DE,#04,#38,#00,#7B,#09,#2B,#0A,#4E
db #09,#77,#08,#DA,#06,#D1,#08,#9E,#0A,#DF,#09,#E7,#07,#F2,#07,#1C,#0A,#4F,#55,#53,#20,#00,#55,#55,#33,#53,#00,#4F,#43,#41,#00,#4F,#57,#32,#4B,#41,#48,#00,#4F,#43,#4F,#20,#00,#4F,#57,#4B,#4F,#57,#00,#4F,#43,#4F,#00,#4F,#57,#4B,#00,#4F,#43,#55,#00,#4F,#57
db #4B,#55,#55,#00,#4F,#51,#55,#00,#4F,#57,#4B,#00,#4F,#58,#55,#00,#4F,#4F,#4B,#53,#55,#55,#00,#4F,#23,#55,#00,#4F,#57,#33,#23,#00,#4F,#55,#47,#48,#20,#00,#4F,#48,#33,#57,#00,#4F,#47,#59,#00,#4F,#4A,#45,#45,#00,#4F,#55,#47,#48,#00,#41,#48,#00,#4F,#4C,#45
db #20,#00,#4F,#57,#32,#4C,#00,#4F,#45,#00,#4F,#57,#33,#00,#4F,#55,#4C,#44,#20,#00,#55,#48,#33,#44,#00,#4F,#58,#4F,#00,#4F,#4F,#4B,#53,#4F,#57,#00,#4F,#23,#4F,#20,#00,#4F,#57,#23,#4F,#57,#00,#4F,#23,#4F,#00,#4F,#57,#32,#23,#00,#4F,#58,#41,#00,#4F,#4F,#4B
db #53,#41,#45,#00,#4F,#23,#41,#00,#4F,#57,#32,#23,#00,#4F,#43,#45,#00,#4F,#57,#53,#48,#00,#4F,#58,#45,#00,#4F,#4F,#4B,#53,#00,#4F,#23,#45,#00,#4F,#57,#33,#23,#00,#4F,#4F,#4B,#00,#55,#48,#33,#4B,#00,#4F,#55,#00,#41,#45,#32,#55,#58,#00,#4F,#55,#52,#00,#41
db #4F,#33,#52,#00,#4F,#49,#43,#00,#4F,#59,#53,#00,#4F,#20,#00,#4F,#57,#00,#4F,#41,#00,#4F,#48,#33,#57,#00,#4F,#52,#45,#20,#00,#41,#4F,#32,#52,#00,#4F,#57,#00,#4F,#57,#00,#4F,#52,#49,#00,#41,#4F,#52,#49,#58,#32,#00,#4F,#4F,#00,#55,#58,#00,#4F,#52,#00,#41
db #4F,#52,#00,#4F,#48,#00,#4F,#48,#00,#4F,#4F,#52,#00,#41,#4F,#33,#52,#00,#4F,#49,#00,#4F,#59,#33,#00,#4F,#59,#00,#4F,#59,#00,#4F,#54,#48,#45,#52,#00,#41,#48,#44,#48,#45,#52,#00,#4F,#52,#52,#00,#4F,#52,#00,#4F,#00,#4F,#4F,#00,#49,#43,#45,#00,#49,#59,#53
db #00,#49,#43,#59,#00,#49,#59,#53,#45,#45,#34,#00,#49,#58,#59,#00,#49,#48,#4B,#53,#45,#45,#00,#49,#23,#59,#00,#49,#59,#23,#45,#45,#00,#49,#52,#4F,#00,#49,#59,#52,#4F,#4F,#00,#49,#59,#00,#49,#59,#00,#49,#54,#4C,#45,#00,#49,#59,#54,#55,#55,#4C,#00,#49,#45
db #44,#00,#41,#59,#33,#44,#00,#49,#58,#45,#00,#49,#48,#4B,#53,#00,#49,#23,#45,#00,#49,#59,#33,#23,#00,#49,#45,#00,#45,#45,#00,#49,#47,#49,#00,#49,#58,#32,#4A,#49,#48,#00,#49,#20,#00,#49,#59,#34,#00,#49,#53,#4D,#00,#49,#58,#33,#53,#55,#55,#4D,#00,#49,#47
db #48,#00,#49,#59,#32,#00,#49,#52,#00,#45,#52,#34,#00,#49,#00,#49,#48,#00,#20,#44,#41,#56,#49,#44,#20,#00,#20,#44,#41,#59,#56,#49,#48,#44,#00,#20,#50,#53,#59,#00,#20,#53,#49,#59,#00,#20,#47,#49,#56,#45,#00,#20,#47,#49,#48,#56,#00,#20,#59,#4F,#55,#52,#20
db #00,#20,#59,#41,#4F,#52,#00,#20,#43,#48,#41,#49,#52,#20,#00,#20,#43,#48,#41,#49,#52,#00,#20,#57,#48,#59,#20,#00,#20,#57,#49,#59,#00,#20,#45,#20,#00,#20,#45,#45,#00,#20,#23,#45,#52,#45,#00,#20,#23,#45,#45,#33,#45,#52,#00,#20,#4F,#55,#47,#48,#54,#00,#20
db #41,#4F,#32,#54,#00,#20,#43,#4F,#55,#47,#48,#20,#00,#20,#4B,#4F,#4F,#46,#00,#20,#23,#4F,#55,#47,#48,#20,#00,#20,#23,#41,#48,#46,#00,#20,#53,#43,#49,#00,#20,#53,#49,#59,#00,#20,#59,#45,#53,#20,#00,#20,#59,#45,#48,#33,#53,#00,#20,#23,#49,#45,#00,#20,#23
db #49,#59,#00,#20,#41,#42,#4C,#45,#00,#20,#41,#59,#33,#42,#4C,#00,#20,#47,#45,#54,#00,#20,#47,#45,#48,#54,#00,#20,#41,#4E,#59,#00,#20,#45,#48,#32,#4E,#45,#45,#00,#20,#55,#23,#45,#00,#20,#59,#55,#58,#57,#23,#00,#20,#4F,#55,#52,#00,#20,#41,#57,#33,#52,#00
db #20,#4F,#4E,#45,#00,#20,#57,#4F,#4F,#4E,#00,#20,#54,#4F,#20,#00,#20,#54,#55,#58,#33,#00,#20,#42,#45,#20,#00,#20,#42,#45,#45,#33,#00,#20,#4F,#46,#20,#00,#20,#4F,#4F,#33,#56,#00,#20,#41,#20,#00,#20,#41,#45,#00,#20,#41,#52,#45,#20,#00,#20,#41,#41,#33,#52
db #00,#20,#57,#4F,#52,#00,#20,#57,#45,#52,#33,#00,#20,#4D,#45,#20,#00,#20,#4D,#45,#45,#33,#00,#20,#47,#49,#00,#20,#4A,#49,#59,#00,#20,#4D,#59,#20,#00,#20,#4D,#49,#59,#00,#20,#49,#53,#20,#00,#20,#49,#58,#34,#53,#00,#20,#53,#43,#00,#20,#53,#4B,#00,#20,#41
db #53,#20,#00,#20,#41,#45,#53,#00,#20,#57,#49,#54,#48,#20,#00,#20,#57,#49,#58,#33,#44,#48,#00,#20,#48,#41,#56,#45,#20,#00,#20,#2F,#48,#41,#45,#33,#56,#00,#20,#42,#59,#20,#00,#20,#42,#49,#59,#31,#00,#20,#54,#48,#49,#53,#20,#00,#20,#44,#48,#49,#58,#53,#00
db #20,#57,#45,#20,#00,#20,#57,#45,#45,#33,#00,#20,#54,#48,#45,#59,#20,#00,#20,#44,#48,#41,#59,#32,#00,#20,#48,#41,#53,#20,#00,#20,#2F,#48,#41,#45,#53,#00,#20,#54,#48,#45,#49,#52,#20,#00,#20,#44,#48,#41,#49,#32,#52,#00,#20,#54,#48,#41,#4E,#20,#00,#20,#44
db #48,#41,#45,#34,#4E,#00,#20,#4F,#4E,#4C,#59,#20,#00,#20,#4F,#57,#33,#4E,#4C,#45,#45,#00,#20,#50,#45,#4F,#00,#20,#50,#45,#45,#32,#00,#20,#53,#48,#45,#20,#00,#20,#53,#48,#45,#45,#33,#00,#20,#53,#41,#49,#44,#20,#00,#20,#53,#41,#49,#34,#44,#00,#20,#53,#4F
db #4D,#45,#20,#00,#20,#53,#41,#48,#33,#4D,#00,#20,#54,#48,#45,#4E,#20,#00,#20,#44,#48,#45,#48,#33,#4E,#00,#20,#4D,#45,#20,#00,#20,#4D,#45,#45,#00,#20,#47,#4F,#54,#4F,#20,#00,#20,#47,#4F,#57,#54,#55,#57,#00,#20,#4D,#4F,#53,#54,#20,#00,#20,#4D,#4F,#57,#32
db #53,#54,#00,#20,#00,#20,#00,#47,#54,#48,#20,#00,#54,#48,#00,#47,#48,#4F,#54,#49,#00,#46,#49,#48,#34,#53,#48,#00,#47,#55,#45,#20,#00,#47,#00,#47,#4F,#4F,#00,#47,#55,#48,#32,#00,#47,#45,#4E,#00,#4A,#45,#48,#33,#4E,#00,#47,#48,#4F,#00,#47,#4F,#48,#32,#57
db #00,#47,#47,#00,#47,#00,#47,#00,#47,#00,#4E,#47,#45,#52,#00,#4E,#58,#47,#45,#52,#00,#4E,#47,#53,#20,#00,#4E,#58,#5A,#00,#4E,#4F,#57,#00,#4E,#41,#57,#00,#4E,#47,#45,#00,#4E,#4A,#00,#4E,#49,#4F,#4E,#00,#4E,#49,#58,#55,#55,#4E,#00,#4E,#4E,#00,#4E,#00,#4E
db #47,#20,#00,#4E,#58,#00,#4E,#47,#00,#4E,#58,#47,#00,#4E,#00,#4E,#00,#41,#47,#45,#20,#00,#41,#59,#4A,#00,#41,#55,#47,#48,#00,#41,#41,#33,#46,#00,#41,#49,#47,#48,#00,#41,#59,#00,#41,#42,#4C,#45,#00,#41,#48,#42,#55,#55,#4C,#00,#41,#43,#49,#00,#41,#45,#53
db #49,#48,#00,#41,#58,#49,#00,#41,#45,#4B,#53,#49,#48,#00,#41,#23,#49,#00,#41,#59,#33,#23,#00,#41,#52,#45,#00,#41,#49,#33,#52,#00,#41,#20,#00,#41,#48,#00,#41,#4E,#47,#45,#20,#00,#41,#59,#32,#4E,#4A,#00,#41,#4E,#47,#45,#00,#41,#59,#32,#4E,#4A,#55,#55,#00
db #41,#4C,#4C,#59,#00,#41,#45,#32,#4C,#45,#45,#00,#41,#58,#41,#00,#41,#45,#4B,#53,#41,#45,#00,#41,#43,#41,#00,#41,#45,#4B,#41,#45,#00,#41,#23,#41,#00,#41,#59,#23,#00,#41,#43,#45,#00,#41,#59,#53,#00,#41,#58,#45,#00,#41,#45,#4B,#53,#00,#41,#23,#45,#00,#41
db #59,#34,#23,#00,#41,#43,#59,#00,#41,#59,#53,#45,#45,#00,#41,#43,#48,#00,#41,#45,#43,#48,#00,#41,#43,#4B,#00,#41,#45,#4B,#00,#41,#43,#43,#00,#41,#45,#4B,#00,#41,#43,#00,#41,#45,#4B,#00,#41,#58,#4F,#00,#41,#45,#4B,#53,#4F,#57,#00,#41,#23,#4F,#00,#41,#59
db #23,#00,#41,#55,#00,#41,#4F,#33,#00,#41,#56,#49,#00,#41,#59,#32,#56,#49,#58,#00,#41,#4C,#4B,#00,#41,#4F,#52,#4B,#00,#41,#52,#00,#41,#41,#33,#00,#41,#46,#00,#41,#41,#32,#46,#00,#41,#5A,#59,#00,#41,#59,#33,#5A,#45,#45,#00,#41,#4C,#4C,#00,#41,#4F,#32,#4C
db #00,#41,#58,#59,#00,#41,#45,#4B,#53,#45,#45,#00,#41,#23,#59,#00,#41,#49,#49,#58,#23,#45,#45,#00,#41,#57,#00,#41,#57,#00,#41,#49,#00,#41,#59,#32,#00,#41,#49,#52,#00,#41,#49,#52,#00,#41,#59,#00,#41,#59,#00,#41,#52,#20,#00,#41,#41,#33,#52,#00,#41,#52,#52
db #00,#41,#45,#33,#52,#00,#41,#00,#41,#45,#00,#42,#42,#43,#00,#42,#45,#45,#25,#25,#42,#45,#45,#25,#53,#45,#45,#00,#42,#42,#00,#42,#00,#42,#45,#59,#20,#00,#42,#45,#45,#59,#00,#42,#00,#42,#00,#4D,#49,#43,#52,#4F,#00,#4D,#49,#59,#33,#4B,#52,#4F,#57,#00,#4D
db #42,#20,#00,#4D,#00,#4D,#4D,#00,#4D,#00,#4D,#00,#4D,#00,#54,#57,#4F,#00,#54,#55,#57,#00,#54,#48,#52,#45,#45,#00,#54,#48,#52,#45,#45,#00,#54,#43,#48,#00,#43,#48,#00,#54,#4C,#45,#00,#54,#4C,#00,#54,#55,#23,#45,#00,#43,#48,#55,#57,#23,#00,#54,#49,#4F,#00
db #53,#48,#41,#48,#00,#54,#49,#41,#00,#53,#48,#49,#58,#55,#55,#00,#54,#48,#45,#20,#00,#44,#48,#55,#55,#25,#20,#00,#54,#48,#00,#54,#48,#00,#54,#54,#00,#54,#00,#54,#00,#54,#00,#46,#4F,#55,#52,#00,#46,#41,#4F,#33,#52,#00,#46,#4F,#4F,#54,#00,#46,#55,#48,#32
db #54,#00,#46,#46,#00,#46,#00,#46,#00,#46,#00,#45,#49,#47,#48,#54,#00,#41,#59,#54,#45,#00,#45,#52,#59,#20,#00,#45,#48,#32,#52,#45,#45,#00,#45,#52,#52,#00,#45,#48,#32,#52,#00,#45,#53,#20,#00,#53,#00,#45,#46,#55,#4C,#20,#00,#46,#55,#55,#4C,#00,#45,#41,#53
db #45,#20,#00,#45,#45,#5A,#00,#45,#20,#00,#25,#00,#45,#57,#00,#49,#48,#55,#57,#00,#45,#55,#00,#49,#48,#55,#48,#32,#00,#45,#45,#00,#45,#45,#34,#00,#45,#52,#45,#00,#41,#49,#52,#00,#45,#52,#00,#45,#52,#00,#45,#59,#00,#41,#59,#00,#45,#41,#00,#45,#45,#33,#00
db #45,#44,#20,#00,#25,#44,#00,#45,#00,#45,#48,#00,#4B,#4E,#00,#4E,#00,#4B,#45,#59,#20,#00,#4B,#45,#45,#59,#00,#4B,#00,#4B,#00,#58,#43,#00,#4B,#53,#00,#58,#00,#4B,#53,#00,#59,#53,#00,#49,#48,#32,#53,#00,#59,#50,#45,#00,#49,#59,#32,#50,#00,#59,#45,#20,#00
db #49,#59,#00,#59,#20,#00,#45,#45,#00,#59,#4F,#55,#20,#00,#59,#55,#57,#00,#59,#00,#59,#00,#43,#48,#4E,#00,#4B,#4E,#00,#43,#49,#00,#53,#49,#48,#00,#43,#48,#52,#00,#4B,#52,#00,#43,#4F,#4D,#45,#20,#00,#4B,#41,#48,#4D,#00,#43,#4F,#57,#00,#4B,#41,#57,#00,#43
db #45,#20,#00,#53,#00,#43,#45,#00,#53,#45,#48,#32,#00,#43,#48,#00,#43,#48,#00,#43,#43,#00,#4B,#00,#43,#4B,#00,#4B,#00,#43,#50,#43,#00,#53,#45,#45,#20,#50,#45,#45,#20,#53,#45,#45,#00,#43,#00,#4B,#00,#53,#55,#50,#45,#52,#49,#4F,#52,#00,#53,#55,#58,#32,#50
db #45,#45,#33,#52,#49,#48,#41,#4F,#52,#00,#53,#48,#41,#4C,#4C,#00,#53,#48,#41,#45,#4C,#00,#53,#54,#49,#4F,#4E,#00,#53,#25,#43,#48,#55,#55,#4E,#00,#53,#45,#53,#20,#00,#53,#49,#58,#5A,#00,#53,#53,#00,#53,#00,#53,#49,#4F,#00,#5A,#48,#55,#55,#00,#53,#48,#00
db #53,#48,#00,#53,#43,#00,#53,#4B,#00,#53,#00,#53,#00,#55,#45,#20,#00,#55,#57,#36,#00,#55,#52,#45,#20,#00,#55,#48,#33,#52,#00,#55,#59,#00,#49,#59,#33,#00,#55,#43,#45,#00,#55,#57,#53,#00,#55,#23,#45,#00,#59,#55,#57,#33,#23,#00,#55,#23,#41,#00,#55,#58,#57
db #23,#00,#55,#43,#49,#00,#55,#57,#53,#49,#48,#00,#55,#23,#49,#00,#59,#55,#58,#57,#23,#00,#55,#4C,#4C,#00,#55,#48,#33,#4C,#00,#55,#48,#00,#55,#48,#00,#55,#4C,#20,#00,#55,#55,#4C,#00,#55,#41,#4C,#00,#59,#55,#55,#4C,#00,#55,#52,#00,#45,#52,#33,#52,#00,#55
db #52,#52,#00,#41,#48,#52,#00,#55,#00,#41,#48,#00,#52,#45,#41,#54,#00,#52,#41,#59,#33,#54,#00,#52,#52,#00,#52,#00,#52,#00,#52,#00,#48,#4F,#57,#00,#2F,#48,#41,#57,#32,#00,#48,#45,#20,#00,#2F,#48,#45,#45,#34,#00,#48,#00,#2F,#48,#00,#50,#4F,#57,#00,#50,#41
db #57,#33,#00,#50,#52,#4F,#47,#00,#50,#52,#4F,#57,#32,#47,#00,#50,#48,#00,#46,#00,#50,#50,#00,#50,#00,#50,#4C,#59,#00,#50,#4C,#49,#59,#00,#50,#00,#50,#00,#44,#4F,#57,#00,#44,#41,#57,#32,#00,#44,#4F,#20,#00,#44,#55,#48,#34,#57,#00,#44,#47,#00,#4A,#00,#44
db #48,#00,#44,#48,#00,#44,#44,#00,#44,#00,#44,#00,#44,#00,#4C,#45,#20,#00,#55,#55,#4C,#00,#4C,#4C,#00,#4C,#00,#4C,#00,#4C,#00,#57,#48,#4F,#00,#2F,#48,#55,#48,#57,#00,#57,#41,#53,#20,#00,#57,#4F,#4F,#5A,#00,#57,#48,#41,#00,#57,#4F,#4F,#33,#00,#57,#41,#54
db #00,#57,#41,#4F,#34,#54,#00,#57,#48,#00,#57,#00,#57,#52,#00,#52,#00,#57,#4F,#4F,#00,#57,#55,#48,#00,#57,#00,#57,#00,#5A,#5A,#00,#5A,#00,#5A,#48,#00,#5A,#48,#00,#5A,#00,#5A,#00,#51,#55,#00,#4B,#57,#00,#51,#00,#4B,#00,#30,#00,#5A,#49,#48,#35,#52,#4F,#57
db #32,#20,#00,#31,#00,#57,#4F,#4F,#33,#4E,#20,#00,#32,#00,#54,#55,#48,#32,#57,#20,#00,#33,#00,#54,#48,#52,#45,#45,#33,#20,#00,#34,#00,#46,#41,#4F,#33,#52,#20,#00,#35,#00,#46,#49,#59,#33,#56,#20,#00,#36,#00,#53,#49,#48,#34,#4B,#53,#20,#00,#37,#00,#53,#45
db #48,#33,#56,#55,#55,#4E,#20,#00,#38,#00,#41,#59,#33,#54,#20,#00,#39,#00,#4E,#49,#59,#33,#4E,#20,#00,#23,#00,#23,#00,#4A,#00,#4A,#00,#56,#00,#56,#00,#2A

spkdatrel   ;Relocator-Tabelle
dw #101,#105,#108,#10b,#10e,#116,#14d,#150,#156,#15a,#168,#16e,#173
dw #177,#17a,#17f,#183,#188,#18c,#191,#196,#199,#19d
dw #1a0,#1a7,#1ad,#1bd,#1c0,#1d1,#1d4,#1dc,#1e0
dw #1e4,#1e7,#1ec,#1f0,#1f5,#1f9,#1fe,#203,#206,#20a,#20d,#211,#219
dw #21c,#22d,#230,#23b,#23f,#302,#309,#30c,#317,#31f,#324,#329
dw #32d,#330,#333,#339,#33e,#343,#348,#34d,#352,#357,#35c,#361,#366
dw #36b,#370,#375,#37a,#37f,#384,#389,#38e,#393,#398,#39d,#3a2,#3a7,#3ac
dw #3b4,#3b9,#3be,#3c3,#3ca,#3cd,#3ee,#3f2,#3F7,#3FB,#400,#404,#409
dw #40D,#412,#415,#41A,#41D,#422,#426,#42B,#42E,#433,#437,#43C,#440
dw #445,#44C,#44F,#460,#464,#469,#46D,#472,#476,#47B,#482,#485
dw #496,#49A,#49F,#4A3,#4A8,#4AB,#4B0,#4B4,#4B9,#4C0,#4C3,#4D8,#4DC
dw #4E1,#4E5,#4EA,#4ED,#4F2,#4F6,#4FB,#4FE,#503,#506,#50B,#50F,#514
dw #51B,#51E,#533,#537,#53C,#540,#545,#549,#54E,#551,#556,#55A,#55F
dw #566,#569,#572,#576,#57B,#583,#588,#58D,#590,#593,#596,#59B,#59E
dw #5A3,#5A6,#5AB,#5AE,#5B3,#5B8,#5BB,#5C0,#5C3,#5C8,#5CB,#5D0,#5D6
dw #5D9,#5DE,#5E1,#5E6,#5E9,#5EE,#5F5,#601,#605,#60A,#60D,#612,#615
dw #61A,#61D,#622,#626,#62B,#62E,#633,#636,#63B,#649,#64E,#651,#656
dw #659,#65E,#661,#666,#66b,#66E,#673,#676,#67B,#67E,#683,#68D,#690
dw #695,#698,#69D,#6A2,#6A5,#6AA,#6AD,#6B2,#6BC,#6BF,#6C4,#6C7,#6CC
dw #6D1,#6D4,#6D9,#6E3,#6E8,#6Eb,#6F0,#6f5,#6FA,#6FD,#702,#707
dw #70A,#70D,#712,#715,#71A,#71D,#722,#727,#72A,#72F,#734,#737,#73C
dw #741,#744,#749,#74C,#751,#756,#759,#75C,#761,#764,#769,#76C,#76F
dw #774,#779,#77E,#781,#786,#78B,#78E,#791,#796,#799,#79E,#7A3,#7A6
dw #7AB,#7B0,#7B3,#7B8,#7BD,#7C0,#7C3,#7C8,#7CB,#7D3,#7D6,#7E0,#7EE
dw #7FB,#7FF,#804,#808,#80D,#81A,#81F,#824,#829
dw #118e,#1191,#119c,#119F,#11A2,#11A5,#11A8,#11AB,#11AE,#11B1
dw #11DC,#11E5,#11EE,#1209,#1228,#1230,#125E,#126C,#126F,#1272,#1288
dw #1295,#129F,#12A2,#12A5,#12AE,#12B1,#12B7,#12BA,#12BD
dw #12C0,#12C5,#12C8,#12CE,#12D2,#12D6,#12D9,#12DC
dw #12DF,#12E5,#12EA,#12F3,#12FD,#1300,#1304,#1307,#130C,#130F
dw #1313,#1316,#1319,#131D,#1320,#1323,#1327,#1334,#1340,#1344,#134a
dw #134D,#1351,#1362,#136C,#136F,#1373,#1379,#137E,#1389,#138D,#139A
dw #139D,#13A2,#13AC,#13B2,#13B5,#13B8,#13BB,#13D2,#13D8,#13DC,#13E2
dw #13e6,#14FF,#1505,#150C,#150F,#1513,#1517,#151D,#1522,#1539,#1540
dw 0


;==============================================================================
;### DATEN-TEIL ###############################################################
;==============================================================================

prgdatbeg

;### Verschiedenes
prgmsginf1  db "Speech V1.1",0
prgmsginf2  db " Copyright (C) 1986 by Amsoft",0
prgmsginf3  db " Ported to SymbOS by Prodatron",0

prgwintit   db "Speech V1.1",0

prgobjtxt1  db "Say",0
prgobjtxt2  db "Speak",0
prgobjtxt3  db "About",0
prgobjtxt4  db "Quit",0

prgobjtxt5  db "Left",0
prgobjtxt6  db "Center",0
prgobjtxt7  db "Right",0

prgobjtxt8  db "Pitch",0
prgobjtxt9  db "Channel",0
prgobjtxta  db "09",0

;==============================================================================
;### TRANSFER-TEIL ############################################################
;==============================================================================

prgtrnbeg
;### PRGPRZS -> Stack fr Programm-Prozess
        ds 128
prgstk  ds 6*2
        dw prgprz
prgprzn db 0
prgmsgb ds 14

;### INFO-FENSTER #############################################################

prgmsginf  dw prgmsginf1,4*1+2,prgmsginf2,4*1+2,prgmsginf3,4*1+2,prgicnbig

;### HAUPT-FENSTER ############################################################

prgwindat   dw #1501,0,079,062,174,64,0,0,174,64,174,64,174,64,prgicnsml,prgwintit,0,0,prgwingrp,0,0:ds 136+14
prgwingrp   db 13,0:dw prgwindat,0,0,256*0+10,0,2,0
prgwindat
dw      00,         0,2,         0,0,1000,1000,0        ;00=Hintergrund
dw      00,255*256+32,prgobjinp1, 04,05,166,12,0        ;01=Eingabe
dw      00,255*256+01,prgobjdsc1, 04,22,166,8,0         ;02=Pitch Text
dw  ctlptc,255*256+24,prgobjsld1, 46,22,100,8,0         ;03=Pitch Slider
dw      00,255*256+01,prgobjdsc3,150,22,10, 8,0         ;04=Pitch Wert
dw      00,255*256+01,prgobjdsc2, 04,34,40, 8,0         ;05=Kanal Text
dw  ctlchn,255*256+18,prgobjrad1, 46,34,40, 8,0         ;06=Kanal links
dw  ctlchn,255*256+18,prgobjrad2, 76,34,40, 8,0         ;07=Kanal center
dw  ctlchn,255*256+18,prgobjrad3,117,34,40, 8,0         ;08=Kanal rechts
dw  ctlsay,255*256+16,prgobjtxt1, 04,46,40,12,0         ;09="Say" Button
dw  ctlspk,255*256+16,prgobjtxt2, 46,46,40,12,0         ;10="Speak" Button
dw  prginf,255*256+16,prgobjtxt3, 88,46,40,12,0         ;11="About" Button
dw  prgend,255*256+16,prgobjtxt4,130,46,40,12,0         ;12="Quit" Button

prgobjinp1 dw prgobjinpb,0,0,0,0,100,0
prgobjinpb ds 101

prgobjsld1  dw 1,8,19,256*255+1

prgobjdsc1  dw prgobjtxt8,2+4
prgobjdsc2  dw prgobjtxt9,2+4
prgobjdsc3  dw prgobjtxta,2+4

prgobjrad1  dw prgobjradv,prgobjtxt5,256*0+2+4,prgobjradk
prgobjrad2  dw prgobjradv,prgobjtxt6,256*1+2+4,prgobjradk
prgobjrad3  dw prgobjradv,prgobjtxt7,256*2+2+4,prgobjradk
prgobjradk  ds 4
prgobjradv  db 1

prgtrnend
